	Page	58,132
; This is a ROM based monitor for an 8086 board that is self contained and
; has the capibility to handel most of the IBM-PC INTS.
;
;	John Monahan			3/1/86
;
;	HISTORY:-
;	v2.5	1/4/86	  Simple monitor enlarged and starts at F000:F000h
;	v2.6	3/12/86	  Add most of IBM Rom Ints.
;
;	See 8086.DOC  for loading details
;
;	Structure of BIOS MONITOR
;		Basic Monitor Functions
;		X Command Hdisk/MSDOS Boot
;		Memory Ints Initilization
;		INT 10  Video Routine
;		INT 16  Keyboard
;		Timer_ints,Equiptment_int,Mem_size,Video_Parms,CRT_char_gen
;		Time_of_day,Key_Break,Tick_Int,Fast_Conout,PCED_IV
;		Support Routines
;		Hardware to SD Systems board
;
LOMAS	EQU	1			; If lomas board present no need to 
					; blank video on scrools

	; Local equates:
ff		equ	0ch
lf		equ	0ah
cr		equ	0dh
bs		equ	0bh
tab		equ	09h
BELL		Equ	07h		; Ascii bell character
ESC_char	Equ	1bh

port_a		equ	60h		; Lomas 8255a chip for keyboard
port_b		equ	61h
port_c		equ	62h
cmd_port	equ	63h

Timer		equ	40h		;8253 timer 0
Timer_ctrl	equ	43h		;8253 control port

KB_data		equ	60h		;port to get Lomas keyboard raw data
KB_ctl		equ	61h		; "	"	"	"	"

constat_port	Equ	0		;SD Systems Status Port
condata_port	Equ	1		;SD Systems Data Port
talkstat	Equ	0a0h		;ACIA to talker status port
talkdata	Equ	0a1h		;ACIA to talker data port	
con_in_rdy	Equ	2		;data available
con_out_rdy	Equ	4		;transmitter ready
;
Z80SWITCH 	EQU	0EDH		;port to switch back in z80
CENTSTAT 	EQU	5H
CENTOUT		EQU	5H
CENTSTROBE 	EQU	4H

iobyte		Equ	0efh		;my front pannell switch
					;bit 0, 0 = printer on 
					;bit 1, 0 = Lomas IBM vidio card on
					;bit 2, 0 = Lomas IBM keyboard on
					;bit 3, 0 = Monocrome on
					;bit 4, 0 = No line feeds
					;bit 5, 0 = Slow display on CRT
					;bit 6, 0 = Format MDisk on any Bootup
					;bit 7, 0 = Dont ever format Mdisk

c6845port	Equ	3d0h		;base port for colour board
bw6845port	Equ	3b0h		;base port for b/w card
keyboard_reset	Equ	0e8h		;port to reset my keyboard to IBM
					;I have the MSDOS A> prompt set to 
					;ESC ESC BS BS A> Once the Consol Output
					;sees this it inputs this port.
;
Equip_Flag_Init	Equ	0100001000101101B
;
;
;   XCOMP HARD DISK DRIVE COMMANDS
;
SKCMD		EQU	3		;SEEK
SKOUT		EQU	1		;SEEK OUTWARD
NOPC		EQU	40H		;NO PRE-COMPENSATION
LOWRT		EQU	80H		;LOW WRITE CURRENT
RCA		EQU	0EAH		;COMMAND TO XCOMP
RSA		EQU	0D7H		;COMMAND TO XCOMP
MAXCYL		EQU	644	
MAXHEAD 	EQU	7
LZONE		EQU	644
HFILE$SIZE 	EQU	(9000h-100h)/256  ;NO OF SECTORS FOR MSDOS
MAXSEC		EQU	32		;SECTORS PER TRACK
;
;   XCOMP HARD DISK DRIVE STATUS
;
READY		EQU	1		;DRIVE READY
WRTFLT		EQU	2		;WRITE FAULT
TK00		EQU	4		;TRACK ZERO
RAWINDX		EQU	20H		;RAW INDEX
;
;   CONTROLLER COMMANDS
;
BANK0		EQU	0		;BANK 0 SELECT
BANK1		EQU	1		;BANK 1 SELECT
DBENB		EQU	2		;DATA BUFFER ENABLE
CBENB		EQU	4		;COMPARE BUFFER ENABLE
HSTART		EQU	8		;START COMMAND
;
;   DRIVE/CONTROLLER I/O
;
CBASE		EQU	78H		;BASE ADR OF THE CONTROLLER
DRCSR		EQU	CBASE		;DRIVE COMMAND/STATUS
EXTCMD		EQU	CBASE+1		;EXTENDED COMMNAND REGISTER
LOSC		EQU	CBASE+2		;SEEK COUNT, LSB
HISC		EQU	CBASE+3		;  * MSB
CTCSR		EQU	CBASE+4		;CONTROLLER COMMAND/STATUS
CTBFR		EQU	CBASE+5		;CONTROLLER BUFFER ADDRESS
CTDP		EQU	CBASE+6		;CONTROLLER DATA PORT
;
MASTER_PIC_PORT	equ	020h		;base Reg of 8259
NS_EOI		equ	20h		;Non specific end of interrupt
RD_ISR		Equ	0bh		; Read ISR register of 8259
MASTER_ICW_1	equ	13h		;ICW4 req, single master,edge trigger
MASTER_ICW_2	equ	8h		;base of chips interrupt vectors
MASTER_ICW_4	equ	09h		;86 mode,normal EOI, buffered mode.
;
;
;8259A Programmable Interrupt Controller Equates
;
; Interupt Structure			;Only a master 8259A
;
;  MASTER PIC:	IRQ0 = 			;system tick 18.2/sec
;		IRQ1 = 			;keyboard IV on Lomas board (like IBM)
;		IRQ2 = 			;keyboard IV on SD-Systems board
;		IRQ3 = 
;		IRQ4 = 
;		IRQ5 = 
;		IRQ6 = 			;cpm86 60/sec timer click
;
;	Keyboard values for IBM bios routines
ins_state	equ	80h
caps_state	equ	40h
num_state	equ	20h
scroll_state	equ	10h
alt_shift	equ	08h
ctl_shift	equ	04h
left_shift	equ	02h
right_shift	equ	01h

ins_shift	equ	80h
caps_shift	equ	40h
num_shift	equ	20h
scroll_shift	equ	10h
hold_state	equ	08h

num_key		equ	69
scroll_key	equ	70
alt_key		equ	56
ctl_key		equ	29
caps_key	equ	58
left_key	equ	42
right_key	equ	54
ins_key		equ	82
del_key		equ	83
;
;
;
;  ---------------------SET UP DEFINED AREAS IN LOWER RAM--------------------------
;
;		     SETUP 8086 INTERRUPT LOCATIONS FOR MSDOS
;
Abs0		Segment	at 0

		Org	5h*4
PrintSc_IV	label 	word

		Org	8h*4
Timer_IV	label	word

		Org	9h*4
Lomas_KB_IV	label	word

		Org	0ah*4	
SD_KB_IV	label	word

		Org	10h*4
Video_IV	label	word
 	
		Org	11h*4
Equiptment_Vec	label	word

		Org	12h*4
Memory_IV	label   word

		Org	15h*4
CASSETTE_IV	label	word

		Org	16h*4
KBOARD_IV	label	word

		Org	17h*4
Printer_IV	label	word
		
		Org	1ah*4
Time_day_Vec	label	word

		Org	1bh*4
Break_Vec	label 	word

		Org	1ch*4
Tick_Vec	label	word

		Org	1dh*4
Parm_Ptr	label	dword

		Org	1fh*4
Ext_Ptr		label	dword

		Org	29h*4
FASTCON_IV	label	word

		Org	61h*4
CED_IV		label	word

		Org	0efe0h
STACK	label	word			;location for stack pointer

Abs0	ends
;
;
;	Data area for IBM ram variables in low memory
;
Data		Segment	At 40h
		Org	10h
Equip_Flag	Dw	?
Iobyte_store	Db	?		;store for last switch setting

		Org	17h
KB_Flag		db	?
KB_Flag_1	db	?
Alt_input	db	?
Buffer_head	dw	?
Buffer_tail	dw	?
KB_Buffer	dw	16 dup(?)
KB_buffer_end	label	word	
Qsize		equ	16

		Org	49h
Crt_Mode	db	?
Crt_Cols	dw	?
Crt_Len		dw	?
Crt_Start	dw	?
Cursor_Posn	dw	8 Dup(?)
Cursor_Mode	dw	?
Active_page	db	?
Addr_6845	dw	?
Crt_mode_set	db	?
Crt_Pallette	db	?

		Org	67h
IO_ROM_INIT	Dw	?
IO_ROM_SEG	Dw	?
Intr_Flag	Db	?

Timer_Low	Dw	?
Timer_High	Dw	?
Timer_Ofl	Db	?
Bios_break	Db	?

Data		Ends

xxdata		Segment at 50h
status_byte	DB	?		;Print Screen Flag
xxdata	ends

;	IBM-PC Video Board RAM area 

Video_Ram	segment   At 	0b800h
regen		label	byte
regenw		label	word
		db	16384	dup(?)
Video_Ram	ends
;
;
.XLIST

;============================================================================
;		START OF MONITOR CODE
;============================================================================
;
IO	Group	CODE,LASTSEG

CODE		Segment  

	Assume cs:IO, ds:IO, es:IO, ss:Abs0
;
	org	0d000h		;<----will start at F000:d000h
;
begin:	jmp	init		;reset all registers
begin1:	JMP	HBOOT		;BOOT UP MSDOS (AFTER INITILIZING INTS, VIDEO ETC)
ZCI:	jmp	ci		;simple console input to SD Systems board
ZCO:	jmp	co		;simple console output
ZCSTS:	jmp	csts		;simple consol status
ZCI_ECHO: jmp	cico		;simple console in with echo
	jmp	lo		;simple printer output
	jmp	lstat		;simple printer status
	jmp	reinit		;warm start
;
;					;Hardware initilization etc.
init:	
	cld				;set direction up
	cli				;disabel interrupts
	mov	ax,cs			;note cs will be 0f000h
	mov	ds,ax
	mov	es,ax
	mov	ax,abs0			;must put stack in RAM
	mov	ss,ax
	mov	sp,offset stack		;<----MUST point to a RAM area
	mov	bp,0			;<----will store flag varables here

	mov	al,99h			;seup keyboard port on Lomas board
	out	cmd_port,al
	mov	al,0cch
	out	port_b,al
	mov	al,4ch
	out	port_b,al
					;Setup Timer
	mov	al,36h			;sel timer 0, LSB,MSB,Mode 3
	out	timer_ctrl,al
	mov	al,0
	out	timer,al
	out	timer,al
					; Program the 8259A
	mov	al,MASTER_ICW_1		;(1bh)
	out	MASTER_PIC_PORT,al
	mov	al,MASTER_ICW_2		;(20h) ints start at 20h
	out	MASTER_PIC_PORT+1,al
	mov	al,MASTER_ICW_4		;(0dh) set to 8086 mode
	out	MASTER_PIC_PORT+1,al
	mov	al,0ffh			;mask off all for now
	out	MASTER_PIC_PORT+1,al	;see below in Con_read routines for mask changes 
					;NOTE will sti flag in IO.ASM
	mov	bx,offset signon
	call	pmsg
;
reinit:	mov	ax,cs		;just in case ds or es messed up
	mov	ds,ax		;set ds & es for messages
	mov	es,ax		;NOTE DS: WILL BE USED FOR ALL MSGS
	call	crlf		;WITH THIS 8086 MONITOR
	mov	cl,'>'
	call	ZCO
	mov	cl,Bell
	call	ZCO
;
mainloop: call	ZCI_ECHO	;get a command
	mov	ah,0
	cmp	al,'A'
	jb	reinit		;must be A to Z
	cmp	al,'Z'
	jg	reinit
	sub	al,'A'		;calculate offset
	shl	al,1		;X 2
	add	ax,Offset ctable
	mov	bx,ax
	mov	ax, [bx]	;get location of routine
	call	ax
	jmp	reinit		;finished 
;
;---------------------------------------------------------------------
MENU:	mov	bx,offset msg13	;Print menue on CRT
	call	pmsg
	ret
;---------------------------------------------------------------------
FILL:	call	setup		;up to 2 X 20 bits into DX & BX (+ DS)
	call	clength		;must be < 64k (DX-BX into CX)
	push	ds		;because ds is destroyed by getparmal
	call	getparmal	;get ascii fill hex character to al
	pop	ds
floop:	mov	[bx],al		;note this is ds:[bx]
	inc	bx
	loop	floop
	ret
;------------------------------------------------------------------------
VERIFY:	call	setup		;Get up to 20X2 bits in DX,BX and DS
	push	ds		;save DS for below
	call	clength
	inc	cx
	mov	si,bx
	push	cx
	mov	cx,0ffffh
	call	getparmb	;ds has segment info
	pop	cx
	mov	ax,ds		;DS to ES
	mov	es,ax
	pop	ds		;now ds and es are set correctly
	mov	di,bx
	call	crlf
vloop:	
   repe	cmps	Byte Ptr [di],Byte Ptr [si]
	cmp	cx,0
	jne	verr		;if error describe where it is
	ret
;
verr:	push	ds		;must relocate ds
	mov	ax,cs
	mov	ds,ax
	cmp	bp, 0ffh	;flag for heading done
	jz	verr1
	push	bx
	mov	bx,offset vhead
	call	pmsg
	pop	bx
	mov	bp, 0ffh	;so next time indicates done
verr1:	pop	ds		;get back ds
	mov	bx,si
	dec	bx
	call	outadd
	mov	al,[bx]
	mov	dh,al		;store ah in dh
	call	hexout
	call	blank
	call	blank
	mov	bx,di
	dec	bx
	call	outadd1
	mov	al,es:[bx]
	push	ax
	call	hexout
	call	blank
	pop	ax
	xor	al,dh		;store from above
	call	binout
	call	blank
	call	blank
	call	ctlchek
	jmp	vloop
;
;----------------------------------------------------------------------
MOVE:	call	setup		;up to 2 X 20 bits into DX & BX (+ DS)
	push	ds		;save ds
	cmp	al,cr
	jnz	m1z
	jmp	err
m1z:	call	clength		;must be < 64k (DX-BX into CX)
	push	bx		;save bx for now
	call	setup		;up to 1 X 20 bits into BX (+ DS)
	mov	ax,ds		;have from DS:DX--CX(len) to DS:BX
	mov	es,ax			
	mov	di,bx
	pop	bx		;now get back bx
	pop	ds		;now get back ds
	mov	si,bx
  rep	movs	Byte Ptr [di], byte Ptr [si]
	ret
;
;-----------------------------------------------------------------------
DUMP:	call	setup		;up to 2 X 20 bits into DX & BX (+ DS)
	and	bl,0f0h		;even up printout
	or	dl,0fh		;also nice ending for Ray G.
	call	clength		;must be < 64k (DX-BX into CX)
	call	outadd		;send start address
dloop1:	mov	al,ds:[bx]
	call	hexout
	call	blank
	mov	al,bl		;test 16 byte boundry
	and	al,0fh
	cmp	al,0fh
	jnz	dnext
notfst:	push	cx		;now print ascii
	push	bx
	push	dx
	mov	cx,8		;first send 8 spaces
	call	tabs
	sub	bx,000fh	;drop back 16 places
	mov	dl,16
dloop2:	mov	al,ds:[bx]
	and	al,7fh
	cmp	al,' '		;filter out control characters
	jnc	dloop3
dloop4:	mov	al,'.'
dloop3:	cmp	al,'~'
	jnc	dloop4
	mov	cl,al
	call	ZCO
	inc	bx
	dec	dl
	jnz	dloop2
	pop	dx
	pop	bx
	pop	cx
	inc	bx
	call	outadd
	jmp	dump1
;
dnext:	inc	bx			
dump1:	loop	dloop1
	ret
;
;----------------------------------------------------------------------
QUERY:	call	ZCI_ECHO	;is it input or output
	cmp	al,'I'
	jz	input
	cmp	al,'O'
	jz	output
	jmp	err		;if not QI or QO then error
input:	push	ds		;ds is altered by setup
	call	setup
	pop	ds
	call	crlf
	mov	dx,bx
	in	al,dx
	push	ax
	call	hexout
	call	blank
	pop	ax
	call	binout
	ret
;
;
output:	push	ds		;play safe 
	call	setup		;up to 2 X 20 bits into DX & BX (+ DS)
	pop	ds
	mov	al,dl		;get port # to DL
	mov	dx,bx
	out	dx,al
	ret
;
;------------------------------------------------------------------------
GOTO	proc	FAR		;to force return far 
	call	setup		;up to 1 X 20 bits into DX & BX (+ DS)
	push	ds		;put CS on stack first
	push	bx		;then offset
	ret			;this will be a ret far instruction
goto	endp
;-------------------------------------------------------------------------
HEXMATH:push	ds
	mov	bx,offset msg9
	call	pmsg
	call	setup
	pop	ds
	push	bx		;save data for the moment
	push	dx
	call	crlf
	mov	bx, offset mhead  ;up to 2 X 20 bits into DX & BX (+ DS)
	call	pmsg
	call	crlf
	pop	dx		;get back data
	pop	bx
	push	bx		;save them again for below
	push	dx
	add	bx,dx
	call	outbx	
	mov	cx,2		;skip over 2 spaces
	call	tabs
	pop	dx		;get back data one more time
	pop	bx
	sub	bx,dx
	call	outbx
	ret
;
;----------------------------------------------------------------------------
NTEST:	cli			;Check RAM., note no stack return must reset 8086
	call	setup1		;get start in ds:bx & es:dx
	push	bx
	call	crlf
	pop	bx
	mov	bp,ds
	mov	cx,bx		;start = ds:bx = bp:cx, finish=es:dx
	xor	ah,ah		;start pattern
;
jj:	mov	ds,bp		;begin location
	mov	bx,cx
;
jj1:	push	ax		;where ever the stack is
	push	bx
	mov	ax,es
	mov	bx,ds
	cmp	bx,ax
	pop	bx
	pop	ax
	jnz	jloop
	cmp	bx,dx
	jz	jend
jloop:	mov	[bx],ah
	mov	al,[bx]
	cmp	ah,al
	jnz	jerror
didit:	inc	bx
	jnz	jj1		;not yet over segment
	push	ax
	mov	ax,ds
	add	ax,1000h
	mov	ds,ax
	pop	ax
	jmp	jj1
jend:	mov	al,'.'
	out	1,al		;no need for status check
	inc	ah		;next test pattern
	jmp	jj
jerror:
	push	ax		;ss and sp are still OK!
	call	outadd		
	pop	ax
	push	ax
	mov	al,ah		;get pattern
	call	binout
	call	blank
	pop	ax		;al has what was recieved
	push	ax
	call	binout
	call	crlf
	call	crlf
	pop	ax
	jmp	didit
;	
;------------------------------------------------------------------------
ESUBST:	call	setup		;up to 2 X 20 bits into DX & BX (+ DS)
nusloop: call	outadd
	mov	cx,8
sloop:	call	blank
	mov	al,ds:[bx]
	push	cx
	push	bx
	push	ax
	call	hexout
	mov	cl,'-'
	call	ZCO
	pop	ax
	pop	bx
	pop	cx
	push	ds			;is messed up by getparmal
	call	getparmal
	pop	ds
	cmp	ah,cr
	je	qtest
	cmp	ah,' '			;is a skip reqs
	jne	snext1
snext:	mov	ds:[bx],al
snext1:	inc	bx
	loop	sloop
	jmp	nusloop
qtest:	ret
;
;------------------------------------------------------------------------
DISPAS:	call	setup
	and	bl,0f0h			;even up printout
	or	dl,0fh			;also nice ending for Ray G.
	call	clength			;length in cx
	call	outadd			;send start address
aloop1:	mov	dl,64			;dx no longer needed
	push	cx			;put length on stack
aloop2:	mov	al,ds:[bx]
	and	al,7fh
	cmp	al,' '			;filter out control characters
	jnc	aloop3
aloop4:	mov	al,'.'
aloop3:	cmp	al,'~'
	jnc	aloop4
	mov	cl,al
	call	ZCO
	inc	bx
	dec	dl
	jnz	aloop2
	call	outadd
	pop	cx			;get back length (was on stack)
	sub	cx,64
	jnc	aloop1
	ret
;
;--------------------------------------------------------------------------
MAP:	call	crlf
	mov	ax,0
	mov	ds,ax			;must start in first segment
	mov	dl,64			;character count
	mov	dh,4			;segment counter(4 lines per segment)
	mov	bx,ax			;need to reset bx (ds = 0 already)
	call	outadd			;start with address
map1:	mov	ax,[bx]			;remember ds is assumed 
	not	ax			;complement data
	mov	[bx],ax
	cmp	ax,[bx]			;did it change
	jne	not_ram
	not	ax			;correct data
	mov	[bx],ax
	mov	cl,'R'
	jmp	nextbk			;get next block
;
not_ram:cmp	ax,0			;ffff->0  must be rom if not 0
	jne	prom
	mov	cl,'.'			;no need to correct data for here
	jmp	nextbk			;get next block
;
prom:	mov	cl,'p'
;
nextbk:	call	ZCO			;send the R,P or "."
	inc	bh			;move 1000h at a time
	dec	dl
	jnz	noline
	mov	dl,64			;reset counter for next line
	dec	dh			;segment counter
	jnz	noseg
	mov	ax,ds
	add	ax,1000h
	jc	mapdone
	mov	ds,ax
	mov	dh,4
noseg:	call	outadd
noline:	jmp	map1
mapdone: ret
;
;---------------------------------------------------------------------------
Z80:	in	al,Z80SWITCH		;this switches control over to Z80
	nop
	nop
	nop
	nop
	nop
	DB	0EAH,0F0H,0FFH,00H,0F0H	;next time will start here
;
;----------------------------------------------------------------------
LAND:	call	coff			;put Heads on landing area
	mov	al,1
	out	extcmd,al
	inc	al
	out	drcsr,al
	call	tkz
	jz	land1
	mov	bx,offset hmsg1		;restore error
	call	pmsg
	jmp	reinit	
land1:
	mov	bx,511			;send heads to landing area
	call	psk
	mov	bx,130
	call	psk
	call	coff
	mov	bx,offset hmsg4
	call	pmsg
	jmp	reinit
;
;#1
;------------- BOOT UP MSDOS FROM HARD DISK -----------------------------
;
HBOOT	Proc 	Near
	
	Assume 	CS:IO, DS:IO

	cld				;First set up enviorment
	cli				;disabel interrupts
	mov	ax,cs			;note CS will be 0f000h
	mov	ds,ax			;note DS will be 0f000h
	mov	es,ax
	mov	ax,abs0			;must put stack in RAM
	mov	ss,ax
	mov	sp,offset stack		;<----MUST point to a RAM area
					;----READ IN MSDOS FROM HDISK------
	call	hsetup			;send microcode to controller
	jz	hdos1
	mov	bx,offset hmsg0		;restore error
	call	pmsg
	jmp	init			;Note need to make new stack	
hdos1:	mov	dh,100			;start cylinder of dos on disk
	mov	dl,1			;start head for dos on disk
	mov	cl,HFILE$SIZE		;# of 256 byte sectors on disk
	mov	ch,14h			;start sector
	mov	bx,100			;do a seek to cylinder 100 (64h)
	call	psk
	mov	bx,0100h		;DMA load address
	call	crlf
hloop:
	push	bx			;save dma address

	push	cx			;indicate each sector read on crt
	mov	cl,'.'
	call	ZCO
	pop	cx

	call	hread			;read a sector
	pop	bx
	jz	hloop11
	mov	bx,offset hmsg2		;read error
	call	pmsg
	jmp	init
hloop11:
	mov	al,DBENB		;enabel data buffer
	out	ctcsr,al
	xor	ax,ax
	push	ds
	push	cx
	mov	ds,ax			;set ds: to 0
	
	Assume	DS:Nothing

	out	ctbfr,al		;set bfr adr = 0	
	mov	cl,0			;256 bytes/sector
	in	al,ctdp			;prime input
	nop
inir:	in	al,ctdp
	mov	DS:[bx],al
	inc	bx
	dec	cl			
	jnz	inir
	pop	cx			;get back cl=dos size & ch= sector#
	pop	ds

	Assume	DS:IO

 	dec	cl			;last sector yet?

	jz	dos_ints_etc		;NOW INITILIZE HARDWARE AND INTS
;
hloop1:
	inc	ch			;up one sector
	cmp	ch,maxsec
	jb	hloop
	xor	ch,ch			;0 sector on next track
	inc	dl			;go to next head
	cmp	dl,maxhead
	jnz	hloop			;7 heads per cylinder
	push	bx
	mov	bx,1
	call	psk			;step inward one track
	pop	bx
	inc	dh			;to next cylinder
	mov	dl,0			;back to head 0
	jmp	hloop
HBOOT	endp
;
;#############################################################################
;
dos_ints_etc	Proc	Near		;code to setup ports for dos hardware
					;and to setup ints in ram 0 - 400h
	Assume	CS:IO, DS:Nothing
					; Initialize interrupt vector tables 
	Xor	Ax,Ax			; Need a 0
	Mov	Es,Ax			; Es points to base of interrupt vectors
	Mov	Ds,Ax
	Mov	Di,Ax			; Es:Di is -> there
	Mov	Ax,Offset D11		; Ax is offset of handler
	Mov	Bx,cs			; Bx is segbase of IO system
	Shl	Bx,1
	Shl	Bx,1
	Shl	Bx,1
	Shl	Bx,1
	Add	Ax,Bx
	Xor	Bx,Bx			; Bx:Ax is 0:abs Offset of D11
	Mov	Cx,256			; 256 vectors to initialize
	Cld				; Ensure index pointer increments
IV_Init_Lp:
	Stos	Es:Word Ptr [Di]	; Store offset of interrupt routine
	Xchg	Ax,Bx			; Segbase to Ax
	Stos	Es:Word Ptr [Di]	; Move to next vector
	Xchg	Ax,Bx			; Offset to Ax
	Inc	Bx			; Bump segbase
	Sub	Ax,16			; Bump offset
	Loop	IV_Init_Lp		; Loop for all...

	Mov	Ds:Word Ptr PrintSc_IV,Offset Print_Screen	   ;INT 5H
	Mov	Ds:Word Ptr PrintSc_IV+2,Cs

	Mov	Ds:Word Ptr Timer_IV,Offset Timer_Int	   	   ;INT 08H
	Mov	Ds:Word Ptr Timer_IV+2,Cs

	Mov	Ds:Word Ptr Lomas_KB_IV,Offset KB_Int_8259_1       ;INT 09H
	Mov	Ds:Word Ptr Lomas_KB_IV+2,Cs

	Mov	Ds:Word Ptr SD_KB_IV,Offset KB_Int_8259_2          ;INT 0AH
	Mov	Ds:Word Ptr SD_KB_IV+2,Cs

	Mov	Ds:Word Ptr Video_IV,Offset IBM_Video		   ;INT 10H	
	Mov	DS:Word Ptr Video_IV+2,cs

	Mov	Ds:Word Ptr Equiptment_Vec,Offset Equiptment_Int   ;INT 11H (equiptment check)
	Mov	Ds:Word Ptr Equiptment_Vec+2,Cs

	Mov	Ds:Word Ptr MEMORY_IV,Offset Mem_Size		   ;INT 12H
	Mov	Ds:Word Ptr MEMORY_IV+2,Cs

	Mov	Ds:Word Ptr CASSETTE_IV,Offset Cassette		   ;INT 15H
	Mov	Ds:Word Ptr CASSETTE_IV+2,Cs

	Mov	Ds:Word Ptr KBOARD_IV,Offset Keyboard_IO	   ;INT 16H
	Mov	Ds:Word Ptr KBOARD_IV+2,Cs

	Mov	Ds:Word Ptr Printer_IV,Offset Printer_IO	   ;INT 17H
	Mov	Ds:Word Ptr Printer_IV+2,Cs

	mov	DS:Word Ptr Parm_Ptr,Offset Video_Parms		   ;VIDIO PARMS LOCATION
	Mov	DS:Word Ptr Parm_Ptr+2,Cs

	Mov	Ds:Word Ptr Ext_Ptr,Offset crt_char_gen		   ;EXTRA CHARS LOCATION
	Mov	DS:Word Ptr Ext_ptr+2,cs

	Mov	Ds:Word Ptr Time_day_Vec,Offset Time_of_day	   ;INT 1AH (Time of day)
	Mov	Ds:Word Ptr Time_day_Vec+2,Cs

	Mov	Ds:Word Ptr Break_Vec,Offset Key_Break	   	   ;INT 1BH (keyboard break)
	Mov	Ds:Word Ptr Break_Vec+2,Cs

	Mov	Ds:Word Ptr Tick_Vec,Offset Tick_Int		   ;INT 1CH (control timer ints)
	Mov	Ds:Word Ptr Tick_Vec+2,Cs	

	Mov	Ds:Word Ptr FASTCON_IV,Offset Fast_Con		   ;INT 29H
	Mov	Ds:Word Ptr FASTCON_IV+2,Cs

	Mov	Ax,0
	Mov	Ds:Word Ptr CED_IV,Ax		;CED requires this
	Mov	DS:Word Ptr CED_IV+2,Ax

	Mov	bx,400h				;Fill 400-500 with 0's just in 
	mov	cx,100h				;other software assumes this is so
flush:	mov	ds:Word Ptr [bx],ax
	inc	bx
	inc	bx
	loop	flush

	Mov	ax,xxdata
	Mov	ds,ax

	Assume	Ds:xxdata

	Mov	Ds:Byte Ptr Status_byte,0	;zero flag for
						;print screen
						;Recover original data segment:
	Mov	Ax,Data
	Mov	Ds,Ax
	Mov	Es,ax

	Assume	Ds:Data, ES:Data

	Mov	Equip_Flag,Equip_Flag_Init

	Xor	Ax,Ax				;Need 0's for counter
	Mov	Timer_Low,Ax
	Mov	Timer_High,Ax
	Mov	Timer_Ofl,Al

	Mov	Iobyte_store,al			;force board flip routine

	Mov	Buffer_head, offset KB_buffer	;Will also flush buffers
	Mov	Buffer_tail, offset KB_buffer

						;Recover original data segment:
	Mov	Ax,Cs
	Mov	Ds,Ax
	Mov	Es,ax

	Assume	Cs:IO, Ds:IO, Es:IO

	Call	Rom_Scan		; Look for optional extra ROM's	

	Mov	ax,0003h		; Initilize Lomas Video board
	int	10h

	mov	al,0fch			;mask off all except Lomas Keyboard & Timer
	out	MASTER_PIC_PORT+1,al	;see below in Con_read routines for mask changes 
	Mov	Al,NS_EOI		;8259A End of Interrupt command
	out	MASTER_PIC_PORT,al	;Note INTS are NOT enabeled yet	

	DB	0EAH,00H,00H,70H,00H	; Far jump to 70:0000h for DOS

Dos_ints_etc	endp
;
;
;#2
;############################################################################
;--------INT 10   Routines For Console Output to IBM Video Board -------------
;
	Assume	CS:IO, DS:Data, ES:Video_RAM, SS:Nothing
;
IBM_video	Proc far 
	sti
	cld
	push 	es
	push	ds
	push	dx
	push	cx
	push	bx
	push	si
	push	di
	push	ax			;save ax
	mov	al,ah
	xor	ah,ah
	sal	ax,1
	mov	si,ax
	cmp	ax,m1L
	jb	m2
	pop	ax			;save ax
	jmp	video_return

m2:	mov	ax,data
	mov	ds,ax	


	in	al,Iobyte		;determine if output to CRT or IBM Video
	and	al,00000010b
	jz	xm4
	pop	ax			;balance up stack before going
	jmp	Cout			;Remember DS: will be at :data

xm4:	mov	ax,0b800h		;ram for colour board
	mov	di,equip_flag
	and	di,30h			;isolate crt switches
	cmp	di,30h
	jne	m3
	mov	ax,0b000h		;segment for colour card
m3:	mov	es,ax			;set to point to video area
	pop	ax			;get passed value
	mov	ah,crt_mode		;get current mode
	jmp	word ptr cs:[si+ offset m1]	;go to appropiate routine with card type in di
						;mode in AH, video ram in ES
						;and value in al.
;
video_return:
	pop	di
	pop	si
	pop	bx
m15:	pop	cx
	pop	dx
	pop	ds
	pop	es
	iret

IBM_video	endp
;
;
;----------------------------------------------------------------------------
;	INT	29H	Fast Console output. Only AX and flags altered

Fast_Con	Proc	Far		;INT 29H MSDOS FAST CONSOLE OUTPUT
	Assume	Cs:IO

	push	ax
	push	bx
	mov	bx,0
	mov	ah,14			;send in simple TTY mode
	int	10h
	pop	bx
	pop	ax
	iret

Fast_Con	Endp
;
;
;############################################################################
;--------INT 9 & INT A.  Routines For Keyboard Hardware Ints.
;
; I have two modes for keyboard entry depending on bit 2 of IOBYTE switch
; This stuff is tricky. I want only one queue and want it where IBM has
; theirs. They put a ascii char and scan code for each key. 00 + a scan
; for F keys etc. Since I have only ascii in this mode I will put FF +
; ascii for each key. The INT 16 Keyboard routine will take care of the
; rest (see below). If it sees 0 in high byte knows we have a F key and 
; must send it next time. If an FF then send low byte. This way buffer
; heads,tails etc are all compatable.
;
;
KB_Int_8259_2	Proc	Far		;for SD systems keyboard
	Assume	Cs:IO, Ds:Nothing
					;Save interrupt routine register state:
	Sti				;Can allow other interrupts 
	Push	Ax
	Push	Bx			; That's all our interrupt routine uses
	Push	Si
	Push	Ds			

	In	Al,condata_port		; Get data 
	and	al,7fh			; strip 8 bit
	mov	ah,al			; need things this way for buffer
	mov	al,0ffh			; Flag needed to tell Cin ascii only
	
	mov	bx,data
	mov	ds,bx			;ds: to buffer area

	assume	ds:data

	cli				;just in case
	mov	bx,buffer_tail
	mov	si,bx
	add	bx,2
	cmp	bx,offset KB_buffer_end
	jnz	kk55
	mov	bx,offset KB_buffer
kk55:
	cmp	bx,buffer_head
	je	KB_Int_full
	mov	[si],ax			;deposite a SINGLE character
	mov	buffer_tail,bx

KB_Int_Exit:
	pop	DS
	pop	Si
	pop	Bx
	Mov	Al,NS_EOI		; 8259A End of Interrupt command
	out	MASTER_PIC_PORT,al	; Ints are off already so see above
	Pop	Ax
	Iret				; Done...

KB_Int_full:
	Mov	Al,'+'			; Yes -- signal a problem with ++++++'s
	Int	29h			; Output via fast console output!
	Jmp	KB_Int_Exit		; And go to orderly exit...

KB_Int_8259_2	Endp
;
;
;
KB_Int_8259_1	Proc	Far		;Get char from keyboard of Lomas board
	Assume	Cs:IO, Ds:Nothing

	Sti				; Can allow other interrupts now!
	Push	Ax
	Push	Bx
	Push	Cx
	Push	Dx
	Push	Si
	Push	Di
	Push	DS
	Push	ES

	; Get character from keyboard and enqueue in Lomas Board Queue:

	cld				;set foward direction
	mov	ax,data
	mov	ds,ax

	Assume	DS:data

	In	Al,KB_Data		; Get data 
	Push	ax			; save it
	in	al,KB_Ctl
	mov	ah,al
	or	al,80h
	out	kb_ctl,al
	xchg	ah,al
	out	kb_ctl,al
	
	in	al,keyboard_reset	; this will clear Z80 board
	in	al,condata_port		; this will release SD systems int

	pop	ax
	mov	ah,al			; Save scan code

					;Test for an overrun
	cmp	al,0ffh
	jnz	k16			;no then test shift key
	jmp	k62			;Send buffer full signal
k16:
	and	al,07fh			;turn off break bit
	push	cs
	pop	es

	assume	es:IO

	mov	di,offset k6
	mov	cx,k6L
	repne	scasb			;look through table for match

	mov	al,ah			;recover scan code
	je	k17			;jump if match found
	jmp	k25			;else shift not found
k17:
	sub	di,offset k6+1		;adjust ptr to scan code match
	mov	ah,CS:k7[di]		;mask into ah
	test	al,80h
	jnz	k23			;break shift_found

	cmp	ah,scroll_shift
	jae	k18			;if scrool or  toggle
	
	or	kb_flag,ah		;turn on shift bit
	jmp	k26
k18:
	test	Kb_flag,Ctl_shift
	jnz	k25			;jump if ctl state
	cmp	al,ins_key
	jnz	k22			; jmp if not insert key
	test	kb_flag,alt_shift
	jz	k19
	jmp	k25
k19:	Test	kb_flag,Num_state
	jnz	k21
	test	kb_flag, left_shift+ right_shift
	jz	k22
k20:	mov	ax,5230h		;send ascii 0
	jmp	k57
k21:	test	kb_flag, left_shift+ right_shift
	jz	k20

k22:	test	ah,kb_flag_1
	jnz	k26
	or	kb_flag_1,ah
	xor	kb_flag,ah
	cmp	al,ins_key
	jne	k26
	mov	ax,ins_key*256
	jmp	k57

k23:	cmp	ah,scroll_shift
	jae	k24
	not	ah
	and	kb_flag,ah
	cmp	al,alt_key+80h
	jne	k26
	
	mov	al,alt_input
	mov	ah,0
	mov	alt_input,ah
	cmp	al,0
	je	k26
	jmp	k58
k24:
	not	ah
	and	kb_flag_1,ah
	jmp	short k26
k25:
	cmp	al,80h
	jae	k26
	test	kb_flag_1,hold_state
	jnz	k25x
	jmp	k28
k25x:	cmp	al,num_key
	je	k26
	and	kb_flag_1,not hold_state
k26:
	cli				; ******critical code area
	Mov	Al,NS_EOI		; 8259A End of Interrupt command
	out	MASTER_PIC_PORT,al
k27:	pop	ES
	pop	DS
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	Pop	Ax
	Iret				; Done...

k28:
	test	kb_flag,alt_shift
	jnz	k29
	jmp	k38
k29:
	test	kb_flag,ctl_shift
	jz	k31
	cmp	al,del_key
	jne	k31
	mov	cl,07h			;will send a bell
	call	bell1
	mov	ax,cs
	mov	ds,ax

	Assume	CS:IO, ds:IO

	mov	bx,offset reset_msg
	call	smsg
	jmp	begin1			;will do jump to load MSDOS code

	Assume	CS:IO ,DS:data

k31:
	cmp	al,57
	jne	k32
	mov	al,' '
	jmp	k57
k32:
	mov	di,offset k30
	mov	cx,10
	repne   scasb

	jne	k33
	sub	di,offset k30+1
	mov	al,alt_input
	mov	ah,10
	mul	ah
	add	ax,di
	mov	alt_input,al
	jmp	k26
k33:
	mov	alt_input,0
	mov	cx,26
	repne	scasb

	jne	k34
	mov	al,0
	jmp	k57
k34:
	cmp	al,2
	jb	k35
	cmp	al,14
	jae	k35
	add	ah,118
	mov	al,0
	jmp	k57
k35:
	cmp	al,59
	jae	k37
k36:	jmp	k26
k37:	cmp	al,71
	jae	k36
	mov	bx,offset k13
	jmp	k63
k38:
	test	kb_flag,ctl_shift
	jz	k44

	cmp	al,scroll_key		;test for break key
	jne	k39			;no break
	mov	bx,offset kb_buffer
	mov	buffer_head,bx
	mov	buffer_tail,bx
	mov	bios_break,80h		;turn on bios break bit
	int	1bh
					;Note this is different from IBM. I
					;cannot get what they have to work
					;I simply flush all buffers
	Mov	Buffer_head, offset KB_buffer
	Mov	Buffer_tail, offset KB_buffer
	jmp	k26

k39:
	cmp	al,num_key
	jne	k41
	or	kb_flag_1,hold_state
	Mov	Al,NS_EOI		; 8259A End of Interrupt command
	out	MASTER_PIC_PORT,al
					; <<<<< IBM bios has crt off/on here
k40:
	test	kb_flag_1,hold_state
	jnz	k40
	jmp	k27
k41:
	cmp	al,55			;test special case for key 55 (ptrSc)
	jne	k42
	mov	ax,114*256
	jmp	k57
k42:					
	mov	bx,offset k8		;setup translated ctrl keys
	cmp	al,59
	jae	k43
	jmp	k56	
k43:	
	mov	bx,offset k9
	jmp	k63
k44:	
	cmp	al,71			;test for keypad
	jae	k48
	test	kb_flag,left_shift+right_shift
	jz	k54

	cmp	al,15
	jne	k45
	mov	ax,15*256
	jmp	k57
k45:
	cmp	al,55			;special case print screen function
	jne	k46
	Mov	Al,NS_EOI		; 8259A End of Interrupt command
	out	MASTER_PIC_PORT,al
	int	5h			;issue print screen int
	jmp	k27
k46:
	cmp	al,59
	jb	k47
	mov	bx,offset k12
	jmp	k63
k47:	
	mov	bx,offset k11
	jmp	short k56
k48:
	test	kb_flag,num_state
	jnz	k52
	test	kb_flag,left_shift+right_shift
	jnz	k53
k49:
	cmp	al,74			;some special cases
	je	k50			;- key
	cmp	al,78
	je	k51			;+ key
	sub	al,71
	mov	bx,offset k15
	jmp	k64
;
k50:	mov	ax,74*256+'-'
	jmp	short k57
k51:	mov	ax,78*256+'+'
	jmp	short k57
k52:
	test	kb_flag,left_shift+right_shift
	jnz	k49
k53:
	sub	al,70
	mov	bx,offset k14
	jmp	short k56
k54:
	cmp	al,59
	jb	k55
	mov	al,0
	jmp	short k57
k55:
	mov	bx,offset k10
k56:
	dec	al
	xlat	cs:k11
k57:
	cmp	al,-1
	je	k59
	cmp	ah,-1
	je	k59
k58:	
	test	kb_flag,caps_state
	jz	k61

	test	kb_flag, left_shift+right_shift
	jz	k60

	cmp	al,'A'
	jb	k61
	cmp	al,'Z'
	ja	k61
	add	al,'a'-'A'
	jmp	short k61
k59:
	jmp	k26
k60:
	push	ax
	mov	al,'0'
	call	zout
	pop	ax

	cmp	al,'a'
	jb	k61
	cmp	al,'z'
	ja	k61
	sub	al,'a'-'A'
k61:
	mov	bx,buffer_tail
	mov	si,bx			
	call	k4
	cmp	bx,buffer_head
	je	k62
	mov	ds:[si],ax
	mov	buffer_tail,bx
	jmp	k26
k62:
	Mov	Al,'+'			; Yes -- signal a problem with ++++++'s
	Int	29h			; Output via fast console output!
	jmp	k26
k63:
	sub	al,59
k64:
	xlat	cs:k9
	mov	ah,al
	mov	al,0
	jmp	k57
;
KB_Int_8259_1	Endp
;
;#5
;############################################################################
;-------- INT16  Routine For Software reading of keyboard -----------------
;
;
; Keyboard support routine. This corresponds to the IBM Bios INT 16
;
;	Note only AX and Flags reg are altered
;
	Assume	CS:IO,DS:data
Keyboard_IO	Proc 	far

	sti				;all ints on for now
	push	ds
	push	bx
	mov	bx,data
	mov	ds,bx			;establish pointer to data region
	push	ax			;temp store ax
	in	al,IOBYTE
	and	al,00000100b
	cmp	iobyte_store,al
	je	rrd22
	call	board_flip
rrd22:	pop	ax
	or	ah,ah
	jz	k1			;ah=0 = Ascii read
	dec	ah
	jz	k2			;ascii status
	dec	ah
	jz	k3			;shift_status
	dec	ah			
	jz	xk1			;not clear why but MSDOS calls require
	pop	bx			;this format to work with "window dos".
	pop	ds
	iret
k1:
	sti				;pick up a character
	nop
	cli
	mov	bx,buffer_head
	cmp	bx,buffer_tail
	jz	k1
	mov	ax,[bx]			;get scan code
	call	k4
	mov	buffer_head,bx
	pop	bx			;this format.
	pop	ds
	iret

k2:
	cli
	mov	bx,buffer_head
	cmp	bx,buffer_tail
	mov	ax,[bx]
	sti
	jz	kz3
	cmp	al,0ffh
	jne	kz3
	mov	al,ah			;return with ASCII
	or	al,al
kz3:	pop	bx
	pop	ds
	ret	2
k3:
	mov	al,kb_flag
	pop	bx			;this format.
	pop	ds
	iret

xk1:	sti				;pick up a character
	nop
	cli
	mov	Bx,buffer_head	        ;does not matter if Bx is destroyed
	cmp	Bx,buffer_tail
	jz	xk1
	mov	ax,[bx]			;get scan code & ascii
	cmp	al,0ffh			;was it sent from z80 board or is it
	jne	kk4			;second key of F key code
	mov	al,ah
	jmp	kk2
kk4:	cmp	al,0			;will indicate an F key
	jne	kk2			;else if a regular ibm key
	mov	al,0ffh			;flag for next time to take lower byte
	mov	[bx],ax
	mov	al,0			;tell msdos an F key
	jmp	kk3
kk2:	add	bx,2			;inc pointer for next time
kk3:	cmp	bx,offset KB_buffer_end
	jnz	kk5
	mov	bx,offset KB_buffer
kk5:
	mov	buffer_head,bx
	pop	bx			;this format.
	pop	ds
	iret

Keyboard_IO	endp
;
;
k4	Proc	near
	add	bx,2
	cmp	bx,offset kb_buffer_end
	jne	k5
	mov	bx,offset kb_buffer
k5:	ret
k4	endp
;
;
board_flip	proc	near		     ;This routine decides which ints
					     ;for keyboard are active
	Assume	cs:IO, ds:data
					     ;arrive here if keyboard source flip is required
	or	al,al			     ;al contains iobyte && 00000100b
	in	al,MASTER_PIC_PORT+1	     ;will need this in both cases
	jnz	zinput		     	     
	or	al,00000100b		     ;8259a mask xxxxxxx0x = Lomas IBM
	and	al,11111100b		     ;open level 1 & 0 (same as IBM)
	out	MASTER_PIC_PORT+1,al	     ;see below in Con_read routines for mask changes
	mov	bx,offset change1_smsg
	jmp	rd11
zinput:
	or	al,00000011b		     ;8259a mask xxxxx0xx = Z80 board
	and	al,11111011b		     ;open up level 2 of PIC	
	out	MASTER_PIC_PORT+1,al
	mov	bx,offset change2_smsg
rd11:
	push	ds			     ;ds=data need ds=io for now
	mov	ax,cs
	mov	ds,ax			     ;so speaker points to correct seg.

	Assume	cs:IO, ds:io

	call	smsg			     ;send message to speaker
	pop	ds

	Assume	cs:IO, ds:data

	in	al,iobyte
	and	al,00000100b
	mov	iobyte_store,al
	Mov	Al,NS_EOI		     ; 8259A End of Interrupt command
	out	MASTER_PIC_PORT,al

	Mov	Buffer_head, offset KB_buffer; Will also flush buffers
	Mov	Buffer_tail, offset KB_buffer
	ret

board_flip	endp
;
;
;-----------------------------------------------------------------------------
;>>>>> INT 1C  This is the hardware service routine to get control of the timer
; interrupt:
;
Tick_Int	Proc	Far
	Assume	Cs:IO, Ds:IO

	Iret

Tick_Int	Endp
;
;----------------------------------------------------------------------------
;>>>>>>> INT 15 This is the cassette service routine
;
Cassette	Proc	Far
	Assume	CS:IO,	DS:IO

	stc			;This is code for compatibility with GSS drivers
	mov	ax,8600h
	ret	2

Cassette	Endp
;
;
;-----------------------------------------------------------------------------
;>>>>>>INT 1A This is the software interrupt service routine for the time of day
;
Time_of_day	Proc	Far
	Assume	Cs:IO, Ds:Data

	sti			;ints back on
	push	ds
	push	ax
	mov	ax,data
	mov	ds,ax
	pop	ax
	or	ah,ah
	jz	t2
	dec	ah
	jz	t3
t1:
	sti
	pop	ds
	Iret
t2:
	cli
	mov	al,timer_ofl
	mov	timer_ofl,0
	mov	cx,timer_high
	mov	dx,timer_low
	jmp	t1
t3:
	cli
	mov	timer_low,dx
	mov	timer_high,cx
	mov	timer_ofl,0
	jmp	t1

Time_of_day	Endp
;
;----------------------------------------------------------------------------
;>>>> INT 1A   This is the hardware interrupt service routine for the time of day
;
Timer_Int	Proc	Far
	Assume	Cs:IO, Ds:Data

	sti
	push	ds
	push	ax
	push	dx
	mov	ax,data
	mov	ds,ax
	inc	timer_low
	jnz	t4
	inc	timer_high
t4:
	cmp	timer_high,18h
	jnz	t5
	cmp	timer_low,0b0h
	jnz	t5
	mov	timer_high,0
	mov	timer_low,0
	mov	timer_ofl,1
t5:
	nop
t6:
	int	1ch		;transfer control to user routine
	mov	al,NS_EOI
	out	MASTER_PIC_PORT,al
	pop	dx
	pop	ax
	pop	ds
	Iret
Timer_Int	Endp
;
;
;--------------------------------------------------------------------------
;>>>>>>> INT 11 This is the software interrupt service routine for the 
;        GET EQUIPTMENT FLAG
;
Equiptment_Int	Proc	Far
	Assume	Cs:IO, Ds:Nothing

	Sti			; Hardware interrupts back on
	Push	Ds
	Mov	Ax,Data
	Mov	Ds,Ax

	Assume	Ds:Data      
	Mov	Ax,Equip_Flag	; Get equipment flag to Ax

	Pop	Ds
	Assume	Ds:Nothing

	Iret
Equiptment_Int	Endp
;
;--------------------------------------------------------------------------
;>>>>>INT 12  This is the software interrupt service routine to return size of 
; memory
;
Mem_Size	Proc	Far
	Assume	Cs:IO,Ds:IO

	Sti			; Hardware interrupts back on
	Mov	Ax,680		; Assume full size or Ram always
	Iret

Mem_Size	Endp
;
;
;---------------------------------------------------------------------------
; >>>INT 1B This is the code carried out if there was an int 1b due to pressing 
; the keyboard break character
;
Key_Break	Proc	Far
	Assume	CS:IO, DS:IO

	sti
	push	ax
	push	bx
	push	cx
	push	ds
	push	es
	mov	ax,CS
	mov	ds,ax
	mov	bx,offset break_smsg
	call	smsg
	pop	es
	pop	ds
	pop	cx
	pop	bx
	pop	ax
	Iret

Key_Break	Endp
;
;
;----------------------------------------------------------------------------
;
;>>>>>> INT 17H		This is the main printer output routine 
;			ah=0 char in al
;			ah=1 initilize printer
;			ah=2 get printer status
;
Printer_IO	proc	far		;IBM BIOS Int 17h routine
	Assume 	CS:IO, DS:Nothing

	sti				;can turn ints back on
	push	dx
	push	cx
	push	bx			;Note I will ignore IBM's base addess stuff
	or	ah,ah			
	jz	b2			;ah=0 print char
	dec	ah
	jz	b8			;ah=1 initilize printer
	dec	ah
	jz	b5			;ah=2 get printer status
b1:	
	pop	bx
	pop	cx
	pop	dx
	iret
					;-------Print a Character in [AL]
b2:
	mov	dx,ax			;temp store
	mov	bl,1			;<<<< setup timeout value (IBM has 10)
	xor	cx,cx
b3:	call	lstat			;get status of whatever printer is on
	jnz	b4
	loop	b3			;do a time out test
	dec	bl
	jnz	b3
	mov	ah,1			;signify a time out problem
	jmp	short b1
b4:	
	mov	ax,dx			;printer is not busy send status
	call	print			;send char in al
	mov	ax,dx			;return with char in al
	mov	ah,01010000b		;Indicate all went fine
	jmp	short b1
					;-------------Get printer status
b5:
	mov	dx,ax			;do not want to disturbe al
	call	lstat
	mov	al,dl
	jmp	short b1
					;--------------- Initilize printer
b8:
	mov	dx,ax			;same as b5 for now				
	call	lstat
	mov	al,dl
	jmp	short b1
Printer_IO	endp


Lstat	Proc	Near
	Assume	CS:IO, DS:IO

	In	al,centstat		;find out which printer is selected
	test	al,2
	jnz	censtat			;is my Epson
	test	al,20h
	jnz	transtat		;is my Transtar
	xor	al,al			;return zero set for error
	mov	ah,00001000b		;no ack,no sel,io error	
	ret
censtat:
	and	al,00001111b		;xxxx0110 is ready (bit 3=paper,2=fault, 1=select, 0=busy
	cmp	al,00000110b
	jz	general_OK
	test	al,00001000b
	jnz	general_NO_PAPER
	test	al,00000100b
	jz	general_FAULT
BUSY:	xor	al,al			;return zero flag set
	mov	ah,10000000b
	ret	
transtat:
	and	al,11110000b		;0110xxxx is ready (bit 3=paper,2=fault, 1=select, 0=busy
	cmp	al,01100000b
	jz	general_OK
	test	al,10000000b
	jnz	general_NO_PAPER
	test	al,01000000b
	jz	general_FAULT
	jmp	busy			;must be simply busy
;
general_OK:
	xor	al,al
	dec	al			;return with zero flag off
	mov	ah,01010000b
	ret
;
general_NO_PAPER:
	xor	al,al			;return zero flag set
	mov	ah,00100000b
	ret
;
general_FAULT:
	xor	al,al			;return with zero flag set
	mov	ah,00001000b
	ret
Lstat	endp


Print	proc	near
	Assume 	CS:IO, DS:IO

	mov	ah,al			;can assume status is OK (see above)
	mov	al,0ffh
	out	centstrobe,al
	mov	al,ah			;now character
	out	centout,al
	in	al,centstat
	test	al,2
	jnz	lcent
	test	al,20h
	jnz	ltrans
	ret				;should never get to here!
;
lcent:	mov	al,11111110b		;strobe for Epson FX-100 printer
	jmp	short overls
ltrans:	mov	al,11111101b		;strobe for Transtar printer
overls:	out	centstrobe,al
	mov	al,0ffh
	out	centstrobe,al
	ret
Print	endp
;
;
;>>>>>> INT 05H		This is the IBM ROM BIOS routine to dump screen
;			on printer
;			status_byte = 0 no print in progress
;			  "      "  = 1 print in progress ignore a reqyuest
;			  "      "  = 377 error during printing
;
Print_screen	proc	far
	Assume	CS:IO, DS:xxdata

	sti	
	push	ds
	push	ax
	push	bx
	push	cx
	push	dx

	push	cs			;Speak message screen dump is on
	pop	ds			;must have valid DS:
	mov	bx,offset speak_msg
	call	smsg

	mov	ax,xxdata		;get IBM flag to see if ok to print
	mov	ds,ax
	cmp	status_byte,1		;is there a print in progress
	jz	exit
	mov	status_byte,1
	mov	ah,15				;get current screen mode
	int	10h
						;al=mode, ah=cols/line, bh=page
	mov	cl,ah
	mov	ch,25
	call	pcrlf
	push	cx
	mov	ah,3				;get cursor position
	int	10h
	pop	cx
	push	dx				;store cursor position	
	xor	dx,dx				;cursor to 0,0
;
pri10:	mov	ah,2				;set cursor
	int	10h
	mov	ah,8				;read char
	int	10h
	or	al,al				;see if a valid char
	jnz	pri15
	mov	al,' '				;else use a blank
pri15:
	push	dx				;save cursor position
	xor	dx,dx				;indicate printer 1 (not used here)
	xor	ah,ah				;print a char
	int	17h
	pop	dx				;get back cursor
	test	ah,00101001b			;<<<< IBM has test 25h! should be 29h I think
	jnz	err10
	inc	dl				;next column
	cmp	cl,dl
	jnz	pri10
;
	xor	dl,dl				;back to column 0
	mov	ah,dl		
	push	dx				;save new cursor
	call	pcrlf
	pop	dx
	inc	dh
	cmp	ch,dh				;finished yet
	jnz	pri10
pri20:
	pop	dx				;get back cursor
	mov	ah,2
	int	10h
	mov	status_byte,0
	jmp	short exit
err10:
	pop	dx
	mov	ah,2
	int	10h
err20:	mov	status_byte,0ffh

exit:	pop	dx
	pop	cx
	pop	bx
	pop	ax
	pop	ds
	iret

speak_msg	label	byte
	db	'PRINT SCREEN IN PROGRESS',0Dh,0

Print_screen	endp

pcrlf	proc	near
	Assume	CS:IO, DS:Nothing

	xor	dx,dx
	xor	ah,ah
	mov	al,0ah				;a LF
	int	17h				;print it
	xor	ah,ah
	mov	al,0dh				
	int	17h
	ret
pcrlf	endp	
;
;
;
;#3
;----------------------------------------------------------------------------
Cout	Proc	Near

	Assume	cs:io,ds:data

	mov	bx,ax
	cmp	ah,14
	jnz	not_simple_sd		;if not a simple io
	in	al,iobyte
	and	al,00110001b
	cmp	al,00110001b		;check if anything special
	jz	simple_SD
	test	al,1
	jnz	no_printer
	cmp	bl,ESC_char
	jz	no_printer

	mov	ah,0			;send to printer as well
	mov	al,bl
	int	17h
	
no_printer:
	test	al,20h			;delay after sending each character
	jnz	no_wait
	mov	al,4
	call	delay
no_wait:
	test	al,10h			;do not send lf's
	jnz	simple_SD
	cmp	bl,0ah
	jne	simple_SD
	mov	al,']'-40h		;for EOL command
	out	condata_port,al
wait1:	In	Al,constat_port		; Get port status
	And	Al,con_out_rdy		; Able to send character yet ?
	jz	wait1
	jmp	sd_out

Simple_SD:
	cmp	bl,bell
	jnz	sd_out
	mov	al,6h			;code to send bell
	out	condata_port,al
	mov	al,1fh
	call	delay
sd_out:
	In	Al,constat_port		; Get port status
	And	Al,con_out_rdy		; Able to send character yet ?
	jz	sd_out
	mov	al,bl
	Out	condata_port,al
sd_ok:	call	update
	mov	ax,bx			; return with ax intact
	jmp	video_return
;
not_simple_sd:
	jmp	sd_ok			; return for now
;
update:
	ret

Cout	endp
;
;
;----------------------------------------------------------------------------
; This is the null or "hot" interrupt processor. If an unitilized INT is
; picked up it will arrive here with the CS offset corresponding to the
; actual int. Note no assumptions can be made initially on CS or DS so all
; position independent code until we get to good_cs label. Thanks to Geoff
; for the slick code. Note IBM_ROM.ASM also contains code to initilize the 
; ints in RAM 0 to 400H. It will display on CRT ant unitilized ints, either 
; soft or hard from 8259. The regs AX,BX,CX,DX are also shown
;
D11	Proc	Far
	Assume	Cs:IO, Ds:Nothing
	
	Push	Ds		;save regs exactly as they were
	push	Ax
	push	bx
	push	cx
;
	push	cx		;will pick these valuse of Ss:Sp one by one
	push	bx		;in this order
	push	ax
;
	Mov	Ax,Data
	Mov	DS,ax			;NOTE ALL THIS CODE MUST BE
					;POSITION INDEPENDENT CODE
	Assume	DS:Data

	Mov	al,RD_ISR
	out	MASTER_PIC_PORT,al
	in	al,MASTER_PIC_PORT
	mov	ah,al			;keep a copy
	or	al,al			;is it a hardware int
	jnz	Hw_interrupt

	not	ah
	jmp	short Set_int_flag	;indicate software int

Hw_interrupt:
	In	al,MASTER_PIC_PORT+1
	or	al,ah			;mask offlevel being serviced
	out	MASTER_PIC_PORT+1,al
	mov	al,NS_EOI
	out	MASTER_PIC_PORT,al

Set_INT_Flag:
	Mov	Intr_flag,ah		;store flag in memory
	Mov	IO_ROM_INIT,cs		;CS is the int #
;
	mov	ax,cs			;now get CS: to this location
	push	ax
	mov	ax,offset good_cs	;will arrive here
	push	ax
	ret				;<----- Note D11: is a far procedure
d11	endp				;so ret will take cs & offset on stack
;
good_cs	proc	FAR
	Assume	cs:io, ds:data

	cmp	Intr_flag,0ffh		;was it hard or soft int
	jnz	ishard
good1:	mov	bx,offset int_msg1	;Unitilized INT #:-
	call	imsg
	mov	ax,IO_ROM_INIT		;pickup the int #
	call	hexout

	mov	bx,offset int_msg3	; AX=
	call	imsg
	pop	ax			;get [AX] off stack
	call	dhexout

	mov	bx,offset int_msg4	; BX=
	call	imsg
	pop	ax			;get [BX] off stack
	call	dhexout

	mov	bx,offset int_msg5	; CX=
	call	imsg
	pop	ax			;get [CX] off stack
	call	dhexout

	mov	bx,offset int_msg6	; DX=
	call	imsg
	mov	ax,dx			;[DX] was unaltered in all this
	call	dhexout

	mov	bx,offset int_msg7	;finish up with a CR
	call	imsg
	pop	cx			;fixup stack
	pop	bx
	pop	ax
	pop	ds
	iret				;Note must use IRET since that is how
;					;we got here
ishard:	mov	bx,offset int_msg2	;8259, level:-
	call	imsg
	mov	al,Intr_flag
	call	hexout
	jmp	short good1		;the rest is the same as soft ints.


int_msg1	db	0dh,0ah,'Unitilized Int #',0
int_msg2	db	0dh,0ah,'8259, Level:- ',0
int_msg3	db	' AX=',0
int_msg4	db	' BX=',0
int_msg5	db	' CX=',0
int_msg6	db	' DX=',0
int_msg7	db	0dh,0ah,0

good_cs	endp
;
Rom_Scan	Proc	Near
	Assume	Cs:IO, Ds:IO

	Ret

Rom_scan	endp
;
;-----------------------IBM BIOS VIDEO SUPPORT ROUTINES-------------------------------------
;
	Assume	CS:IO, DS:Data, ES:Video_RAM, SS:Nothing
;
;
;
;	INITILIZES VIDEO BOARD TO CORRECT DISPLAY FORMAT
;input:-
;	AH = current mode
;	AL = DISPLAY FORMAT (0-9)
;	di = 30h if colour card
;output:-
;	NONE
;
;
set_mode	proc	near

	mov	dx,c6845port+4		;address of colour card
	mov	bl,0			;mode set for colour
	cmp	di,30h
	jne	m8
	mov	al,7
	mov	dx,bw6845port+4		;address of b/w card
	inc	bl			;mode set for bw card
m8:	mov	ah,al			;save mode in ah
	mov	crt_mode,al		;store it
	mov	addr_6845,dx		;also chip ports
	push	ds
	push	ax
	push	dx			;save 6845 base reg
	add	dx,4			;point to control reg = 3d8h
	mov	al,bl			;get mode
	out	dx,al			;setup chip for new mode
	pop	dx			;back to base reg
	sub	ax,ax
	mov	ds,ax
	
	assume	ds:Abs0

	lds	bx,parm_ptr
	pop	ax			;get back parameters
	
	assume	ds:code

	mov	cx,m4			;length of row table
	cmp	ah,2
	jc	m9			;mode 0 or 1
	add	bx,cx			;go to next row of int table
	cmp	ah,4
	jc	m9			;mode 2 or 3
	add	bx,cx
	cmp	ah,7
	jc	m9			;mode is 4,5 or 6
	add	bx,cx		
;
m9:	push	ax			;save mode
	xor	ah,ah
;
m10:	mov	al,ah			;Block output iniation parms to chip.
	out	dx,al
	inc	dx			;next port
	inc	ah			;next value
	mov	al,[bx]
	out	dx,al
	inc	bx
	dec	dx			;back to pointer reg
	loop	m10
	pop	ax
	pop	ds

	assume	ds:data

	xor	di,di			;fill video with blanks
	mov	crt_start,di		;start address
	mov	active_page,0
	mov	cx,8192			;number of words in colour card
	cmp	ah,4			;test for colour card
	jc	m12
	cmp	ah,7
	je	m11
	xor	ax,ax			;fill for graphics mode
	jmp	short m13
m11:	mov	cx,2048			;buffer size for b/w card
m12:	mov	ax,' '+2*256		;<<<<NOTE IBM USES WHITE ON BLACK (07)
m13: 	rep	stosw
;
	mov	cursor_mode,67h		;set current cursor mode
	mov	al,crt_mode
	xor	ah,ah
	mov	si,ax
	mov	dx,addr_6845
	add	dx,4
	mov	al,cs:[si+offset m7]
	out	dx,al
	mov	crt_mode_set,al		;save that value
	
	mov	al,cs:[si+offset m6]
	xor	ah,ah
	mov	crt_cols,ax
;
	and	si,0eh			;word offset into clear length table
	mov	cx,cs:[si+offset m5]
	mov	crt_len,cx		;save length of crt
	mov	cx,8			;clear all cursor positions
	mov	di,offset cursor_posn
	push	ds
	pop	es
	xor	ax,ax
	rep	stosw
;
	inc	dx			;set overscan port to a default
	mov	al,30h
	cmp	crt_mode,6
	jnz	m14
	mov	al,3fh			;640 x 200 is special case
m14:	out	dx,al
	mov	crt_pallette,al		;store value
	jmp	video_return

set_mode	endp
;
;--------------------------------------------------------------------------
;	SET CURRENT CURSOR VALUE
;input:-
;	AH = current mode
;	CX = CURSOR VALUE, CH (BITS 4-0) START LINE, CL (BITS (4-0) STOP LINE
;output:-
;	NONE
;
set_ctype 	Proc near

	mov	ah,10				;set cursor value
	mov	cursor_mode,cx
	call	m16
	jmp	video_return
;
m16:	mov	dx,addr_6845			;this routine outputs cx to 6845 reg in ah
	mov	al,ah
	out	dx,al
	inc	dx
	mov	al,ch
	out	dx,al
	dec	dx
	mov	al,ah
	inc	al				;point to other data reg
	out	dx,al
	inc	dx
	mov	al,cl
	out	dx,al
	ret
;
set_ctype	endp
;-------------------------------------------------------------------------
;	SET CURRENT CURSOR POSITION TO NEW X-Y VALUE
;input:-
;	AH = current mode
;	DX = ROW,COLUMN OF NEW CURSOR
;	BH = DISPLAY PAGE OF NEW CURSOR (MUST BE 0 FOR GRAPHICS MODE)
;output:-
;	CURSOR IS SET AT 6845 IF DISPLAY PAGE IS CURRENTLY DISPLAYED
;
set_cpos 	Proc	near
	mov	cl,bh				;get display page
	xor	ch,ch
	sal	cx,1
	mov	si,cx
	mov	[si+offset cursor_posn],dx
	cmp	active_page,bh
	jnz	m17				;if not current page abort
	mov	ax,dx
	call	m18
m17:	
	jmp	video_return
set_cpos	endp


m18	proc	near
	call	position
	mov	cx,ax
	add	cx,crt_start
	sar	cx,1
	mov	ah,14				;reg no of cursor
	call	m16
	ret
m18	endp
;
;
;	READ CURSOR POSITION
;input:-
;	BH = PAGE OF CURSOR
;output:-
;	DX = ROW,COLUMN OF THE CURSOR POSITION
;	CX = CURRENT CURSOR MODE
;
read_cursor	proc	near
	mov	bl,bh
	xor	bh,bh
	sal	bx,1
	mov	dx,[bx+offset cursor_posn]
	mov	cx,cursor_mode
	pop	di
	pop	si
	pop	bx
	pop	ax		;discard saved cx and dx
	pop	ax
	pop	ds
	pop	es
	iret
read_cursor	endp
;
;
;	SET THE ACTIVE DISPLAY PAGE
;input:-
;	AL = NEW DISPLAY PAGE
;output:-
;	NONE
;
act_disp_page	proc	near
	mov	active_page,al
	mov	cx,crt_len
	cbw
	push	ax
	mul	cx
	mov	crt_start,ax
	mov	cx,ax
	sar	cx,1
	mov	ah,12
	call	m16
	pop	bx
	sal	bx,1
	mov	ax,[bx+offset cursor_posn]
	call	m18
	jmp	video_return
act_disp_page	endp
;
;
;	SET BACKGROUND COLOUR,OVERSCAN COLOUR, AND FORGROUND COLOUR FOR
;	MEDIUM RESOLUTION GRAPHICS
;input:-
;	BH = 0 THEN BACKGROUND SET FROM LOW BITS OF BL (0-31)
;	BH = 1 THE PALLET SELECTION IS MADE BASED ON LOW BITS OF BL:-
;			0 = GREEN, RED,YELLOW FOR COLOURS 1,2,3
;			1 = BLUE,CYAN,MAGENTA FOR COLOURS 1,2,3
;	BL = COLOUR VALUE TO BE USED
;output:-
;	NONE
;
set_color	proc	near
	mov	dx,addr_6845
	add	dx,5
	mov	al,crt_pallette
	or	bh,bh
	jnz	m20
	and	al,0e0h		;handel colour 0 
	and	bl,1fh
	or	al,bl
m19:	out	dx,al
	mov	crt_pallette,al
	jmp	video_return
;
m20:	and	al,0dfh		;handel colour 1
	shr	bl,1
	jnc	m19
	or	al,20h
	jmp	m19
set_color	endp
;
;	GET CURRENT VIDIO STATE
;output:-
;	AH = NUMBER OF COLUMNS ON SCREEN
;	AL = CURRENT VIDIO MODE
;	BH = CURRENT ACTIVE PAGE
;
video_state	proc	near
	mov	ah,byte ptr crt_cols
	mov	al,crt_mode
	mov	bh,active_page
	pop	di
	pop	si
	pop	cx
	jmp	m15
video_state	endp
;
;
POSITION	proc	near	;ax = row,column
	push	bx		;calculates ram address
	mov	bx,ax
	mov	al,ah
	mul	byte ptr crt_cols
	xor	bh,bh
	add	ax,bx
	sal	ax,1
	pop	bx
	ret
position	endp
;
;	Scroll up text on screen
;	Ah	=	CURRENT CRT MODE
;	AL	=	NUMBER OF ROOLS TO SCROOL
;	CX	=	ROW/COL UPPER LEFT
;	DX	=	ROW/COL LOWER RIGHT
;	BH	=	ATTRIBUTE
;	DS	=	DATA SEGMENT
;	ES	=	VIDEO BUFFER
;
SCROOL_UP	proc	near

	mov	bl,al
	cmp	ah,4
	jc	n1
	cmp	ah,7
	je	n1
	jmp	graphics_up
n1:	push	bx
	mov	ax,cx
	call	scrool_position
	jz	n7
	add	si,ax
	mov	ah,dh
	sub	ah,bl
n2:	call	n10
	add	si,bp
	add	di,bp
	dec	ah
	jnz	n2
n3:	pop	ax
	mov	al,' '		;fill with blanks
n4:	call	n11
	add	di,bp
	dec	bl
	jnz	n4
n5:
IF NOT LOMAS			;the lomas board does not need video on here

	mov	ax,data		;get location
	mov	ds,ax	

	Assume	cs:IO, ds:data
	
	cmp	crt_mode,7
	je	n6		
	mov	al,crt_mode_set
	mov	dx,3d8h		;set colour port
	out	dx,al		
ENDIF
n6:	jmp	video_return
n7:	mov	bl,dh
	jmp	n3
SCROOL_UP	ENDP
;

SCROOL_POSITION proc	near

IF NOT LOMAS			;the lomas board does not need video off here
				;also no need to wait for retrace
	cmp	crt_mode,2
	jb	n9
	cmp	crt_mode,3
	ja	n9
;
	push	dx		;must be 80x25 colour scrool
	mov	dx,3dah
	push	ax
n8:	in	al,dx
	test	al,8		;wait for vertical retrace
	jz	n8
	mov	al,25h
	mov	dx,3d8h
	out	dx,al		;turn off vidio
	pop	ax		;during retrace
	pop	dx
ENDIF
n9:	call	position
	add	ax,crt_start
	mov	di,ax
	mov	si,ax
	sub	dx,cx
	inc	dh
	inc	dl
	xor	ch,ch
	mov	bp,crt_cols
	add	bp,bp
	mov	al,bl
	mul	byte ptr crt_cols
	add	ax,ax
	push	es
	pop	ds
	cmp	bl,0
	ret
scrool_position	endp
;
n10	proc	near	
	mov	cl,dl		;no of columns to move
	push	si
	push	di
     	rep	movsw
	pop	di
	pop	si
	ret
n10	endp
;
n11	proc	near
	mov	cl,dl		;no of columns to clear
	push	di
     	rep	stosw
	pop	di
	ret
n11	endp
;
;
SCROOL_DOWN	proc	near
	std
	mov	bl,al
	cmp	ah,4
	jc	n12
	cmp	ah,7
	je	n12
	jmp	graphics_down
n12:	push	bx
	mov	ax,dx
	call	scrool_position
	jz	n16
	sub	si,ax
	mov	ah,dh
	sub	ah,bl
n13:	call	n10
	sub	si,bp
	sub	di,bp
	dec	ah
	jnz	n13
n14:	pop	ax
	mov	al,' '
n15:	call	n11
	sub	di,bp
	dec	bl
	jnz	n15
	jmp	n5
n16:	mov	bl,dh
	jmp	n14
scrool_down	endp
;
;
;	READ CURRENT CHARACTER AND ATTRIBUTE
;input:-
;	AH = CURRENT CRT MODE
;	BH = DISPLAY PAGE
;	DS = DATA SEGMENT
;	ES = REGEN SEGMENT
;output:-
;	AH = ATTRIBUTE READ
;	AL = CHAR READ
;
read_ac_current proc	near
	cmp	ah,4
	jc	p1
	cmp	ah,7
	je	p1
	jmp	graphics_read
p1:	call	find_position
	mov	si,bx
	mov	dx,addr_6845		;wait for retreace
	add	dx,6
	push	es
	pop	ds
p2:	in	al,dx
	test	al,1
	jnz	p2
	cli				;no more ints
p3:	in	al,dx
	test	al,1
	jz	p3
	lodsw
	jmp	video_return
read_ac_current	endp
;
FIND_POSITION	proc	near
	mov	cl,bh
	xor	ch,ch
	mov	si,cx
	sal	si,1
	mov	ax,[si+offset cursor_posn]
	xor	bx,bx
	jcxz	p5
p4:	add	bx,crt_len
	loop	p4
p5:	call	position
	add	bx,ax
	ret
find_position	endp
;
;
;	WRITE  CHAR AND ATTRIBUATE AT CURRENT CURSOR POSITION
;input:-
;	AH = CURRENT CRT MODE
;	BH = DISPLAY PAGE
;	CX = COUNT OF CHARACTERS TO WRITE
;	AL = CHAR TO WRITE
;	BL = ATTRIBUATE OF CHAR TO WRITE
;	DS = DATA SEGMENT
;	ES = REGEN SEGMENT
;output:-
;	NONE
;
write_ac_current proc	near
	cmp	ah,4
	jc	p6
	cmp	ah,7
	je	p6
	jmp	graphics_write
p6:	mov	ah,bl
	push	ax
	push	cx
	call	find_position
	mov	di,bx
	pop	cx
	pop	bx
p7:	mov	dx,addr_6845
	add	dx,6
p8:	in	al,dx
	test	al,1
	jnz	p8
	cli
p9:	in	al,dx
	test	al,1
	jz	p9
	mov	ax,bx
	stosw
	sti
	loop	p7
	jmp	video_return
write_ac_current  endp
;
;
;	WRITE CHAR AT CURSOR POSITION DO NOT CHANGE ATTRIBUATE
;input:-
;	AH = CURRENT CRT MODE
;	BH = DISPLAY PAGE
;	CX = COUNT OF CHARACTERS TO WRITE
;	AL = CHAR TO WRITE
;	DS = DATA SEGMENT
;	ES = REGEN SEGMENT
;output:-
;	NONE
write_c_current	proc	near
	cmp	ah,4
	jc	p10
	cmp	ah,7
	je	p10
	jmp	graphics_write
p10:	push	ax
	push	cx
	call	find_position
	mov	di,bx
	pop	cx
	pop	bx
p11:	mov	dx,addr_6845
	add	dx,6
p12:	in	al,dx
	test	al,1
	jnz	p12
	cli
p13:	in	al,dx
	test	al,1
	jz	p13
	mov	al,bl
	stosb
	inc	di		;go past attribuate
	loop	p11
	jmp	video_return
write_c_current	endp
;
;
;	READ OR WRITE A DOT AT INDICATED POSITION
;input:-
;	DX = ROW (0-199)
;	CX = COLUMN (0-639)
;	AL = DOT VALUE  (see text)
;	DS = DATA SEGMENT
;	ES = REGEN SEGMENT
;output:-
;	AL = DOT VALUE READ, RIGHT JUSTIFIED
;
read_dot	proc	near
	call	r3
	mov	al,es:[si]
	and	al,ah
	shl	al,cl
	mov	cl,dh
	rol	al,cl
	jmp	video_return
read_dot	endp
;
write_dot	proc	near
	push	ax
	push	ax
	call	r3
	shr	al,cl
	and	al,ah
	mov	cl,es:[si]
	pop	bx
	test	bl,80h
	jnz	r2
	not	ah
	and	cl,ah
	or	al,cl
r1:	mov	es:[si],al
	pop	ax
	jmp	video_return
r2:	xor	al,cl
	jmp	r1
write_dot	endp
;
;
;
;	THIS ROUTINE DETERMINES THE RAM LOCATION OF COL/ROW
;input:-
;	DX = ROW (0-199)
;	CX = COLUMN (0-639)
;output:-
;	SI = OFFSET INTO RAM
;	AH = MASK TO STRIP OF BITS OF INTREST
;	CL = BITS TO SHIFT TO RIGHT JUSTIFY MASK IN AH
;	DH = NO OF BITS IN RESULT
;
R3	proc	near
	push	bx
	push	ax
	mov	al,40h
	push	dx
	and	dl,0FEH
	mul	dl
	pop	dx
	test	dl,1
	jz	r4
	add	ax,2000H
R4:	mov	si,ax
	pop	ax
	mov	dx,cx
;
	mov	bx,2C0H		;determine graphics mode currently in effect
	mov	cx,302h
	cmp	crt_mode,6
	jc	r5
	mov	bx,180h
	mov	cx,703h
r5:	and	ch,dl
	shr	dx,cl
	add	si,dx
	mov	dh,bh
	sub	cl,cl
r6:	ror	al,1
	add	cl,ch
	dec	bh
	jnz	r6
	mov	ah,bl
	shr	ah,cl
	pop	bx
	ret
r3	endp
;
;
;
;	SCROOL UP
;input:-
;	CH,CL = UPPER LEFT HAcD CORNER OF SCREEN
;	DH,DL = LOWER RIGHT HAND CORNER OF SCREEN
;	BH = FILL CHAR FOR BLANK LINES
;	DS = DATA SEGMENT
;	ES = REGEN SEGMENT
;output:-
;	NOTHING
;
graphics_up	proc	near
	mov	bl,al		;save line count
	mov	ax,cx
	call	graph_posn
	mov	di,ax
	sub	dx,cx
	add	dx,101h
	sal	dh,1
	sal	dh,1
	cmp	crt_mode,6
	jnc	r7
	sal	dl,1
	sal	dl,1
r7:	push	es
	pop	ds
	sub	ch,ch
	sal	bl,1
	sal	bl,1
	jz	r11
	mov	al,bl
	mov	ah,80
	mul	ah
	mov	si,di
	add	si,ax
	mov	ah,dh
	sub	ah,bl
;
r8:	call	r17
	sub	si,2000h-80	;next row
	sub	di,2000h-80
	dec	ah
	jnz	r8
r9:	
	mov	al,bh		;fill in vacent lines
r10:	call	r18
	sub	di,2000h-80
	dec	bl
	jnz	r10
	jmp	video_return
r11:	mov	bl,dh
	jmp	r9
graphics_up	endp
;
;
;
;	SCROOL DOWN
;input:-
;	CH,CL = UPPER LEFT HAND CORNER OF SCREEN
;	DH,DL = LOWER RIGHT HAND CORNER OF SCREEN
;	BH = FILL CHAR FOR BLANK LINES
;	DS = DATA SEGMENT
;	ES = REGEN SEGMENT
;output:-
;	NOTHING
;
graphics_down	proc	near
	std
	mov	bl,al
	mov	ax,dx
	call	graph_posn
	mov	di,ax
	sub	dx,cx
	add	dx,101h
	sal	dh,1
	sal	dh,1
	cmp	crt_mode,6
	jnc	r12
;
	sal	dl,1
	sal	di,1
	inc	di
r12:	push	es
	pop	ds
	sub	ch,ch
	add	di,240
	sal	bl,1
	sal	bl,1
	jz	r16
	mov	al,bl
	mov	ah,80
	mul	ah
	mov	si,di
	sub	si,ax
	mov	ah,dh
	sub	ah,bl
;
r13:	call	r17
	sub	si,2000h+80
	sub	di,2000h+80
	dec	ah
	jnz	r13
;
r14:	mov	al,bh
r15:	call	r18
	sub	di,2000h+80
	dec	bl
	jnz	r15
	cld
	jmp	video_return
;
r16:	mov	bl,dh
	jmp	r14
graphics_down	endp
;
r17	proc	near
	mov	cl,dl
	push	si
	push	di
	rep	movsb
	pop	di
	pop	si
	add	si,2000h
	add	di,2000h
	push	si
	push	di
	mov	cl,dl
	rep	movsb
	pop	di
	pop	si
	ret
r17	endp

r18	proc	near
	mov	cl,dl
	push	di
	rep	stosb
	pop	di
	add	di,2000h
	push	di
	mov	cl,dl
	rep	stosb
	pop	di
	ret
r18	endp
;
;
;	GRAPHICS WRITE 
;input:-
;	AL = CHAR TO WRITE
;	BL = COLOUR
;	CX = NO OF CHARACTERS
;	DS = DATA SEGMENT
;	ES = REGEN SEGMENT
;output:-
;	NOTHING
;
graphics_write	proc	near
	mov	ah,0
	push	ax
	call	s26
	mov	di,ax
	pop	ax
	cmp	al,80h		;is image in "rom" ie second half
	jae	s1
	mov	si,offset crt_char_gen	;Image of characters in IBM Rom
	push	cs
	jmp	short s2
;
s1:	sub	al,80h		;image in second half
	push	ds		;save DS: for a moment
	sub	si,si
	mov	ds,si		;ie make DS: = 0

	assume ds:Abs0

	lds	si,ext_ptr	;get offset of custom table
	mov	dx,ds		;get segment of table

	assume	ds:data		;back to normal DS:

	pop	ds
	push	dx
;
s2:	sal	ax,1
	sal	ax,1
	sal	ax,1
	add	si,ax
	cmp	crt_mode,6
	pop	ds
	jc	s7
;
s3:	push	di
	push	si
	mov	dh,4
s4:	lodsb
	test	bl,80h
	jnz	s6
	stosb
	lodsb
s5:	
	mov	es:[di+1fffh],al
	add	di,79
	dec	dh
	jnz	s4
	pop	si
	pop	di
	inc	di
	loop	s3
	jmp	video_return
;
s6:	xor	al,es:[di]
	stosb
	lodsb
	xor	al,es:[di+1fffh]
	jmp	s5
;
s7:	mov	dl,bl			;high res write
	sal	di,1
	call	s19
s8:	push	di
	push	si
	mov	dh,4
s9:	lodsb
	call	s21
	and	ax,bx
	test	dl,80h
	jz	s10
	xor	ah,es:[di]
	xor	al,es:[di+1]
s10:	mov	es:[di],ah
	mov	es:[di+1],al
	lodsb
	call	s21
	and	ax,bx
	test	dl,80h
	jz	s11
	xor	ah,es:[di+2000h]
	xor	al,es:[di+2001h]
s11:	
	mov	es:[di+2000h],ah
	mov	es:[di+2001h],al
	add	di,80
	dec	dh
	jnz	s9
	pop	si
	pop	di
	add	di,2
	loop	s8
	jmp	video_return
graphics_write	endp
;
;	GRAPHICS READ
;input:-
;	NONE (0 IS ASSUMED FOR BACKGROUND COLOUR)
;output:-
;	AL = CHAR  (0 IF NONE THERE)
;
graphics_read	proc	near
	call	s26
	mov	si,ax
	sub	sp,8
	mov	bp,sp
;
	cmp	crt_mode,6
	push	es
	pop	ds
	jc	s13
;
	mov	dh,4
s12:	mov	al,[si]
	mov	[bp],al
	inc	bp
	mov	al,[si+2000h]
	mov	[bp],al
	inc	bp
	add	si,80
	dec	dh
	jnz	s12
	jmp	s15
s13:	sal	si,1
	mov	dh,4
s14:	call	s23
	add	si,2000h
	call	s23
	sub	si,2000h-80
	dec	dh
	jnz	s14
s15:	mov	di,offset crt_char_gen	;char gen in IBM Rom
	push	cs
	pop	es
	sub	bp,8
	mov	si,bp
	cld
	mov	al,0
s16:	push	ss
	pop	ds
	mov	dx,128
s17:	push	si
	push	di
	mov	cx,8
	repe	cmpsb
	
	pop	di
	pop	si
	jz	s18
	inc	al
	add	di,8
	dec	dx
	jnz	s17
;
	cmp	al,0
	je	s18		
	sub	ax,ax
	mov	ds,ax		;set ds to 0

	assume ds:Abs0

	les	di,ext_ptr
	mov	ax,es
	or	ax,di
	jz	s18
	mov	al,128
	jmp	s16

	assume ds:data
;
s18:	add	sp,8
	jmp	video_return
graphics_read	endp
;
;
s19	proc	near
	and	bl,3
	mov	al,bl
	push	cx
	mov	cx,3
s20:	sal	al,1
	sal	al,1
	or	bl,al
	loop	s20
	mov	bh,bl
	pop	cx
	ret
s19	endp
;
s21	proc	near
	push	dx
	push	cx
	push	bx
	mov	dx,0
	mov	cx,1
s22:
	mov	bx,ax
	and	bx,cx
	or	dx,bx
	shl	ax,1
	shl	cx,1
	mov	bx,ax
	and	bx,cx
	or	dx,bx
	shl	cx,1
	jnc	s22
	mov	ax,dx
	pop	bx
	pop	cx
	pop	dx
	ret
s21	endp
;
s23	proc	near
	mov	ah,[si]
	mov	al,[si+1]
	mov	cx,0c000h
	mov	dl,0
s24:	test	ax,cx
	clc
	jz	s25
	stc
s25:	rcl	dl,1
	shr	cx,1
	shr	cx,1
	jnc	s24
	mov	[bp],dl
	inc	bp
	ret
s23	endp
;
s26	proc	near
	mov	ax,cursor_posn

graph_posn label near

	push	bx
	mov	bx,ax
	mov	al,ah
	mul	byte ptr crt_cols
	shl	ax,1
	shl	ax,1
	sub	bh,bh
	add	ax,bx
	pop	bx
	ret
s26	endp
;
;#####
;
;	WRITE_TTY
;input:-
;	AH = CURRENT CRT MODE
;	AL = CHARACTER
;	BL = BACKGROUND CHAR IF IN GRAPHICS MODE
;output:-
;	ALL REGS SAVED
;
write_tty	proc	near
	push	ax
	push	ax
	mov	ah,3
	int	10h
	pop	ax
;
	cmp	al,8
	je	u8
	cmp	al,0dh
	je	u9
	cmp	al,0ah
	je	u10
	cmp	al,07
	je	u11
;
	mov	bh,active_page
	mov	ah,10
	mov	cx,1
	int	10h
;
	inc	dl
	cmp	dl,byte ptr crt_cols
	jnz	u7
	mov	dl,0
	cmp	dh,24
	jnz	u6
;
u1:	mov	ah,2
	mov	bh,0
	int	10h
;
	mov	al,crt_mode
	cmp	al,4
	jc	u2
	cmp	al,7
	mov	bh,0
	jne	u3
;
u2:	mov	ah,8
	int	10h
	mov	bh,ah
u3:	mov	ax,601h
	mov	cx,0
	mov	dh,24
	mov	dl,byte ptr crt_cols
	dec	dl
u4:	int	10h
u5:	pop	ax
	jmp	video_return
;
u6:	inc	dh
u7:	mov	ah,2
	jmp	u4
;
u8:	cmp	dl,0
	je	u7
	dec	dl
	jmp	u7
;
u9:	mov	dl,0
	jmp	u7
;
u10:	cmp	dh,24
	jne	u6
	jmp	u1
;
u11:	mov	bl,2
	call	bell1			;send hardware bell
	jmp	u5
;
write_tty	endp
;
;	LIGHT PEN READ
;input:-
;	NONE
;output:-
;	AH = 0 IF NO LIGHT PEN
;	AH = 1 IF PEN IS VALID
;	(DH,DL) = ROW,COLUMN OF PEN
;	CH = RASTER POSITION
;	BX = PIXEL
;
read_lpen	proc	near
	mov	ah,0
	mov	dx,addr_6845
	add	dx,6
	in	al,dx
	test	al,4
	jnz	v6
;
	test	al,2
	jz	v7
	mov	ah,16
	mov	dx,addr_6845
	mov	al,ah
	out	dx,al
	inc	dx
	in	al,dx
	mov	ch,al
	dec	dx
	inc	ah
	mov	al,ah
	out	dx,al
	inc	dx
	in	al,dx
	mov	ah,ch
;
	mov	bl,crt_mode
	sub	bh,bh
	mov     bl,cs:v1[bx]
	sub	ax,bx
	sub	ax,crt_start
	jns	v2
	mov	ax,0
;
v2:	mov	cl,3
	cmp	crt_mode,4
	jb	v4
	cmp	crt_mode,7
	je	v4
;
	mov	dl,40
	div	dl
	mov	ch,al
	add	ch,ch
	mov	bl,ah
	sub	bh,bh
	cmp	crt_mode,6
	jne	v3
	mov	cl,4
	sal	ah,1

v3:	shl	bx,cl
	mov	dl,ah
	mov	dh,al
	shr	dh,1
	shr	dh,1
	jmp	short v5
;
v4:	div	byte ptr crt_cols
	mov	dh,al
	mov	dl,ah
	sal	al,cl
	mov	ch,al
	mov	bl,ah
	xor	bh,bh
	sal	bx,cl
v5:	mov	ah,1
v6:	push	dx
	mov	dx,addr_6845
	add	dx,7
	out	dx,al
	pop	dx
v7:
	pop	di
	pop	si
	pop	ds
	pop	ds
	pop	ds
	pop	ds
	pop	es
	iret
read_lpen	endp
;
;
;-----------------------GENERAL SUPPORT ROUTINES-------------------------------------
;
		Assume	CS:IO, DS:IO
;
ZOUT	Proc	Near			;This is a simple Console out module 
	Assume	Cs:IO, Ds:IO		;used for testing procedures
	Push	Ax
zout1:	In	Al,constat_port		; Get port status
	And	Al,con_out_rdy		; Able to send character yet ?
	jz	zout1
	Pop	Ax
	Out	condata_port,al
	Ret
ZOUT	Endp
;
;
;   ROUTINE TO PRINT A STRING   DS:BX = START OF STRING  $ = FINISH
;
pmsg:	push	cx
print1:	mov	al, [bx]	
	inc	bx
	cmp	al,'$'
	jnz	print2
	pop	cx
	ret
print2:	mov	cl,al
	call	ZCO
	jmp	print1
;
;
;   ROUTINE TO SPEAK A STRING   DS:BX = START OF STRING  $ = 0
;
smsg		Proc	near
	assume	Cs:IO, Ds:IO

	mov	ah,[bx]
	or	ah,ah
	jz	smsg1
smsg2:	mov	al,15h
	out	talkstat,al
	in	al,talkstat
	and	al,2h
	jz	smsg2
	mov	al,ah
	out	talkdata,al
	inc	bx
	jmp	short smsg
smsg1:	ret
smsg		Endp

;	CHECK FOR ^S or ESC  AT CONSOL
;
ctlchek: call	ZCSTS
	cmp	al,0
	jz	ctlexit
	call	ZCI_ECHO
	cmp	al,'S'-40h
	jnz	ctlcchek		;possibly ^C
wait:	call	ZCSTS
	cmp	al,0
	jz	wait
	ret
ctlcchek: cmp	al,esc_char
	jz	err
ctlexit: ret
;
;	SEND CRLF
crlf:	push	cx
	call	ctlchek
	mov	cl,cr
	call	ZCO
	mov	cl,lf
	call	ZCO
	pop	cx
	ret
;
;	PRINT A BLANK SPACE
blank:	push	cx
	mov	cx,1
	call	tabs
	pop	cx
	ret
;
;	TABS			;[cx] = no of spaces
tabs:	push	cx
	mov	cl,' '
	call	ZCO
	pop	cx
	loop	tabs
	ret
;
;	ERROR ABORT ROUTINE
err:	mov	cl,'*'
	call	ZCO
	mov	sp,offset stack
	jmp	reinit
;
;	BINARY OUTPUT		;send what is in [al]
binout:	push	cx
	mov	cx,8
binout1: push	cx
	shl	al,1
	jb	bout1
	mov	cl,'0'
	push	ax
	call	ZCO
	pop	ax
	jmp	binend
bout1:	mov	cl,'1'
	push	ax
	call	ZCO
	pop	ax
binend:	pop	cx
	loop	binout1
	pop	cx
	ret
;
;	HEXOUT			;output the 2 hex digits in [al]
hexout:	push	cx
	push	ax
	mov	cl,4		;first isolate low nibble
	shr	al,cl
	call	hexdigout
	pop	ax
	call	hexdigout	;get upper nibble
	pop	cx
	ret
;
hexdigout: and	al,0fh		;convert nibble to ascii
	add	al,90h
	daa
	adc	al,40h
	daa
	mov	cl,al
	call	ZCO
	ret
;
;	HEXCHK			;check for a valid HEX DIGIT
hexchk:	sub	al,'0'		;convert to binary if ok set carry if problem
	jb	hret
	cmp	al,0ah
	cmc	
	jnb	hret
	sub	al,7
	cmp	al,10
	jb	hret
	cmp	al,16
	cmc
hret:	ret
;
;	GETPARMB		
getparmb: mov	bx,0		;get 20 bit parameter to BX+DS 
loopb:	call	ZCI_ECHO
	cmp	al,'0'		;alphanumeric?
	jb	bexit
	push	cx
	push	bx		;force the highest nibble to ds:
	and	bx,0f000h
	mov	ds,bx
	pop	bx
	mov	cl,4
	shl	bx,cl		;shift in last addition
	pop	cx
	call	hexchk		;convert to binary and check it
	jb	err
	add	bl,al
	loop	loopb
	ret
;
bexit:	cmp	al,' '		;terminate with a sp or cr only
	je	bgood
	cmp	al,','
	je	bgood
	cmp	al,cr
	je	bgood
	jmp	err
bgood:	mov	ah,al		;save terminator
	ret
;
;
;	SETUP			;get parameters in BX & DX +DS (cx not altered)
setup:	push	cx		;BX = DX if only one parameter
	mov	cx,0ffffh
	call	getparmb	;get 20 bit parameter to BX+DS 
	cmp	ah,cr
	je	set1
	push	ds		;save first ds
	mov	dx,bx		;store bx in dx for the moment
	call	getparmb	;get 20 bit parameter to BX+DS 
	xchg	bx,dx		;set them in the right order
	mov	ax,ds		;save second ds
	pop	cx		;get back first ds put it in cx
	cmp	ax,cx
	jz	set2
	jmp	err
set1:	mov	dx,bx
set2:	pop	cx
	ret
;
;	SETUP1			;get parameters in DS:BX & ES:DX
setup1:	push	cx		;BX = DX if only one parameter
	mov	cx,0ffffh
	call	getparmb	;get 20 bit parameter to BX+DS 
	push	ds		;save first ds
	mov	dx,bx		;store bx in dx for the moment
	call	getparmb	;get 20 bit parameter to BX+DS 
	xchg	bx,dx		;set them in the right order
	mov	ax,ds		;save second ds
	mov	es,ax		;note ES: lost from now on
	pop	ds		;get back first ds 
	pop	cx
	ret
;
;	CLENGTH			;cx = (dx-bx)+1	if bx>dx err
clength: push	dx
	cmp	dx,bx
	jnb	cl1
	jmp	err
cl1:	sub	dx,bx
	mov	cx,dx
	inc	cx		;count = difference +1
	pop	dx
	ret
;
;	GETPARMAL		;al <--- ascii hex from consol
getparmal: push	bx		;terminator in ah
	push	cx
	push	dx
	mov	dl,al		;store old value
	mov	cx,0ffffh
	call	getparmb	;get 20 bit parameter to BX+DS 
	cmp	cx,0ffffh
	jne	gquit		;no change req if 0ffff
	mov	bl,dl
gquit:	mov	al,bl
	pop	dx
	pop	cx
	pop	bx
	ret
;
;	OUTBX			;bx output as 4 hex digits
outbx:	push	ax
	mov	al,bh
	call	hexout
	mov	al,bl
	call	hexout
	pop	ax
	ret
;	
;	OUTADD			;send to console a crlf then address ds+bx
outadd:	call	crlf
	push	cx
	mov	ax,ds
outadd2:mov	cl,12
	shr	ax,cl		;get high nibble down
	call	hexdigout
	call	outbx
	call	blank
	pop	cx
	ret
;
outadd1:push	cx		;same but send upper nibble of es reg
	mov	ax,es
	jmp	outadd2
;

dhexout	proc	near
	push	ax
	mov	al,ah
	call	hexout			;first send ah byte in two nibbles
	pop	ax
	call	hexout
	ret
dhexout	endp	
		
	
hex1	proc	near
	and	al,0fh
	cmp	al,9
	jbe	hex09
	add	al,'A' - '0' -10
hex09:	add	al,'0'
	int	29h			;send as fast con_out (all regs OK)
	ret
hex1	endp

imsg	proc	near
	mov	al,CS:[bx]
	or	al,al
	jz	imsgdone
	int	29h
	inc	bx
	jmp	imsg
imsgdone: ret
imsg	endp

;
;	CODE TO LOAD IN SECTORS FROM HARD DISK TO BOOT MSDOS
;
hsetup	Proc	Near
	Assume	CS:IO,DS:IO
	
	XOR	AL,AL
	OUT	ctcsr,AL
	nop
	nop
	OUT	drcsr,AL
	nop
	nop
	OUT	extcmd,AL
	mov	bx,offset rdcode
	call	squirt
	MOV	BX,Offset wrtcode
	CALL	squirt
	MOV	AL,1
	OUT	extcmd,AL
	nop
	nop
	INC	AL
	OUT	drcsr,AL
	nop			;hardware seems to require this
	nop
	call	xrdy
	call	tkz
	ret
hsetup	endp
;
;	Read 256 Bytes into Xcomp buffer
;
hread:	mov	ah,10		;retry count
	mov	al,CBENB	;=4
	out	CTCSR,al
	nop
	nop
	mov	al,RCA		;=0eah
	out	CTBFR,al
	call	hsetsec		;send track, sector, & heads to Xcomp
d02:	
	call	xrdy
	jz	d022
	ret
d022:	mov	al,BANK0
	out	ctcsr,al
	nop
	nop
	mov	al,RSA
	out	CTBFR,al
	nop
	mov	al,BANK0
	or	al,HSTART	;start CMD=8
	out	CTCSR,al
	nop
	nop
	mov	bx,0
rd2:	in	al,ctcsr	;get controller status
	ror	al,1
	jc	rd3
	dec	bx
	jnz	rd2
	xor	al,al
	out	CTCSR,al
	jmp	rd4
rd3:
	in	al,ctcsr
	and	al,0eh
	mov	bh,al		;temp store al
	xor	al,al
	out	ctcsr,al
	nop
	nop
	in	al,drcsr
	and	al,WRTFLT
	jz	rd9
	call	clrdf
rd9:	or	al,bh
	jnz	try_again
	ret
try_again:
	dec	ah
	jnz	d02
rd4:	or	al,1
	ret
;
;
Hsetsec:push	ax		;save retry count
	mov	al,dh		;get cylinder
	out	ctdp,al		;send low then high byte
	nop
	nop
	mov	al,0		;is always < 256 cylinders in this case
	out	ctdp,al
	nop
	nop
	mov	al,dl
	out	ctdp,al		;then head
	nop
	nop
	mov	al,ch
	out	ctdp,al		;then sector
	mov	al,dl		;head again
	add	al,al		;for hardware
	add	al,al
	or	al,1		;to mentain drive select
	or	al,nopc		;< 320 cylinders
	out	extcmd,al
	pop	ax
	ret
;
tkz:	call	tzt
	jnz	tkz1
	ret
tkz1:	mov	bx,511
	call	rtz
	jnz	tkz2
	ret
tkz2:	mov	bx,lzone-511
	call	rtz
	call	tzt
	jnz	rezz
	ret
rezz:	or	al,1
	ret
;
rtz:	call	xrdy			;move heads to track 0
	mov	al,bl
	out	losc,al
	nop
	nop
	mov	al,bh
	out	hisc,al
	nop
	nop
	mov	al,skout
	out	extcmd,al
	nop
	nop
	mov	al,skcmd
	out	drcsr,al
	call	wsc
;
tzt:	in	al,drcsr
	and	al,tk00
	xor	al,tk00
	ret
;
wsc:	mov	bx,0
wsc1:	in	al,drcsr
	rcl	al,1
	jnc	wsc2
	ret
wsc2:	dec	bx
	nop
	jnz	wsc1
	pop	ax			;balance stack
	jmp	rezz
;
;
xrdy:	in	al,drcsr		;get drive status
	and	al,READY
	xor	al,READY
	jnz	xrdy1
	ret				;if z
xrdy1:	or	al,1
	ret
;
clrdf:	xor	al,al			;deselect drive
	out	extcmd,al
	nop
	nop
	mov	al,1			;reselect it
	out	extcmd,al
	ret
;
;
psk:	call	xrdy
	mov	al,bl
	out	losc,al
	nop
	nop
	mov	al,bh
	out	hisc,al
	nop
	nop
	mov	al,3			;seek inward
	out	extcmd,al
	nop
	nop
	mov	al,skcmd
	out	drcsr,al
;
lwsc:	in	al,drcsr
	rcl	al,1
	jnc	lwsc
	ret
;
coff:	xor	al,al
	out	ctcsr,al
	out	drcsr,al
	out	extcmd,al
	ret

;	---squirt microcode---
;
squirt:	MOV	AL,byte ptr[BX]
	OUT	ctcsr,AL		;slct bank
	INC	BX
	MOV	AL,byte ptr [BX]
	OUT	ctbfr,AL		;set ctlr bfr adr
	INC	BX
;
sq1:	MOV	AL,byte ptr [bx]
	OR	AL,AL
	JNZ	sq5	
	RET				;rif done
sq5:	INC	BX			;incr tbl adr
	MOV	CH,AL			;b = count
	RCL	AL,1
	JB	sq3			;jif repeat
;
sq2:	MOV	AL,byte ptr [bx]
	OUT	ctdp,AL			;output control info
	INC	BX
	DEC	CH
	JNZ	sq2
	JMP	sq1			;do next string
;
sq3:	OR	AL,AL			;clear cy
	RCR	AL,1
	MOV	CH,AL			;b = count
	MOV	AL,byte ptr [bx]
	INC	BX
sq4:	OUT	ctdp,AL			;output repeat control info
	DEC	CH
	JNZ	sq4
	JMP	sq1			;do next string
;
;
;<<<<<< MAIN CONSOL OUTPUT ROUTINE TO SD SYSTEMS BOARD >>>>>>>>>>>>>>>>>>>>>>>>>
;
CO:	IN	AL,IOBYTE
	TEST	AL,1H		;BIT 0,A  CHECK IF OUTPUT TO LIST IS ALSO REQ
	JZ	LOX
	TEST	AL,10H		;BIT 4,A  KILL LF'S IF THIS IS 0
	JNZ	SDCONO
	MOV	AL,CL
	CMP	AL,LF
	JZ	SDCON5		;KILL LF'S
	PUSH	CX		;ALL OTHERE CHARACTERS SEND EOL THEN CHARACTER
	MOV	CL,']'-40H	;FOR CLEAR TO END OF LINE
	CALL	SDCONO		;BECAUSE EOL IS SENT FOR EACH CHARACTER THE
	POP	CX		;TYPE RATE IS NICELY SLOWED DOWN TO ~ 60 BAUD
	JMP	SDCONO		;AT NO FURTHER EXPENSE |
SDCON5:	MOV	AL,CL
	RET
;
LOX:	CALL	SDCONO		;OUTPUT TO BOTH PRINTER & CONSOLE
	JMP	LO
;
SDCONO:	IN	AL,constat_port	;SD SYSTEMS VIDIO BOARD PORT
	AND	AL,con_out_rdy
	JZ	SDCONO
	MOV	AL,CL
	CMP	AL,07H		;IS IT A BELL
	JZ	BELL1
	CMP	AL,0H		;SD BOARD CANNOT TAKE A NULL
	JNZ	LX2
	RET

LX2:	OUT	condata_port,AL
	IN	AL,IOBYTE
	TEST	AL,20H		;BIT 5,A SEE IF TIME DELAY REQ WITH CO:
	JNZ	LX3
	MOV	AL,20
	CALL	DELAY
LX3:	MOV	AL,CL		;MAKE SURE TO RETURN WITH [AL] CONTAINING CHAR
	RET

;
BELL1:	MOV	AL,06H		;SEND A BELL
	OUT	condata_port,AL
	MOV	AL,1FH
	CALL	DELAY
	MOV	AL,CL
	OUT	condata_port,AL
	RET
;
;
DELAY:	DEC	AL		;GENERAL COUNT DOWN TIME DELAY
	JNZ	LX4	
	RET			;LENGTH SET IN [A]
LX4:	PUSH	AX
	MOV	AL,05H
MORE:	DEC	AL
	PUSH	AX
	XOR	AL,AL
MORE2:	DEC	AL
	JNZ	MORE2
	POP	AX
	JNZ	MORE
	POP	AX
	JMP	DELAY
;
; 
;<<<<<<< MAIN CONSOL STATUS ROUTINE FROM SD SYSTEMS BOARD >>>>>>>>>>>>>>>>>>>>>>
;
CSTS:	IN	AL,constat_port
	AND	AL,con_in_rdy
	JNZ	CST1
	RET				;RETURN WITH 0 IN [A] IF NOTHING THERE
CST1:	DEC	AL
	RET				;RETURN WITH 0FFH IN [A] IF SOMETHING
;
;
;<<<<<<< MAIN CONSOL INPUT ROUTINE FROM SD SYSTEMS BOARD >>>>>>>>>>>>>>>>>>>>
;
CI:	CALL	CSTS		;NEED CONSTAT TO CLEAN UP SHIFT KEYS ETC
	JZ	CI
	IN	AL,condata_port
	AND	AL,7FH
	RET
;
;
;<<<<<<<<<<<<<<<<<<<<<< MAIN PRINTER OUTPUT ROUTINE >>>>>>>>>>>>>>>>>>>>>>>>>
;
LO:	CALL	LSTAT
	JZ	LO
	MOV	AL,0FFH
	OUT	CENTSTROBE,AL
	MOV	AL,CL
	OUT	CENTOUT,AL
	IN	AL,CENTSTAT
	TEST	AL,2
	JZ	lo1
	jmp	LCENT
lo1:	TEST	AL,20H
	jz	lo2
	jmp	LTRANS
lo2:	RET				;NO STROBE SINCE NOT SELECTED
;
;
CICO:	CALL	CI		;CONSOLE INPUT WITH ECHO ON CONSOLE + LC->UC
	CMP	AL,' '
	JB	CHECK		;ACCEPT ONLY SP,ESC,CR,LF
	CMP	AL,'a'
	JB	CIC1
	CMP	AL,'z'+1
	JA	CIC1
	AND	AL,5FH		;THIS CONVERTS ALL LC->UC
CIC1:	PUSH	AX
	PUSH	CX
	MOV	CL,AL
	CALL	CO		;DISPLAY ON CONSOLE
	POP	CX
	POP	AX
	RET
;
CHECK:	CMP	AL,CR
	JZ	CIC1
	CMP	AL,LF
	JZ	CIC1
	CMP	AL,ESC_char
	JZ	CIC1
	MOV	AL,BELL		;SEND BELL TO INDICATE BAD DATA
	JMP	CIC1
;
;
;	org	0f800h		;For compatability with  older software
;	jmp	begin		;I will have a jump here since old Z80 monitors
				;push code at 500h to cause a far jump to f000:f800
				;insetad of f000:f000.
;----------------------------------------------------------------------------
;
	Assume	CS:IO, DS:IO
;
ctable	dw	map		;A
	dw	err		;B
	dw	err		;C
	dw	dump		;D
	dw	err		;E
	dw	fill		;F
	dw	goto		;G
	dw	hexmath		;H
	dw	err		;I
	dw	ntest		;J
	dw	menu		;K
	dw	Land		;L
	dw	move		;M
	dw	err		;N
	dw	err		;O
	dw	err		;P
	dw	QUERY		;Q
	dw	err		;R
	dw	esubst		;S
	dw	dispas		;T
	dw	err		;U
	dw	verify		;V
	dw	err		;W
	dw	HBOOT		;X
	dw	err		;Y
	dw	Z80		;Z
;
;
signon:		db	17H,11H,cr,lf,'8086 Monitor V2.6  4/27/1986'
CLEANUP: 	db	1H,10H,11H,17H,07H,'$'
mhead		db	'Sum   Diff$'
vhead		db	'Source  Destination  Difference$'
hmsg0:		db	0dh,0ah,'Drive not Ready',07h,'$'
hmsg1:		db	0dh,0ah,'Restore error',07h,'$'
hmsg2:		db	0dh,0ah,'Read error',07h,'$'
hmsg4:		db	0dh,0ah,'OK to Power down',07h,'$'
MSG9:		db	CR,LF,'Hex Math, Enter:- $'
Change1_smsg	db	'STANDERD I B M  KEYBOARD WITH FUNCTION KEES',0DH,0
Change2_smsg	db	'SPECIAL I B M KEYBOARD',0DH,0
Break_smsg	db	'KEYBOARD BREAK',0DH,0
reset_msg	db	'REE BOOT EM S DOS',0dh,0	
;
MSG13:
  DB CR,LF,LF
  DB 'A Memmap B        C          D Disp   F Fill  G Goto    H Math   I     '
  DB CR,LF
  DB 'J Test   K Menu   L Land     M Move   O       P         Q Port   S Subs'
  DB CR,LF
  DB 'T Type   V Verify X DOS(H)   Y        Z Back to Z80'
  DB CR,LF,'$'
;
;
;	---read microcode for Xcomp controller initilization
;
rpt	EQU	80h
;
wrtcode	db	1
	db	0d3h
	db	2,40h
	db	41h
	db	rpt+3,40h
	db	rpt+12,6dh
	db	1,63h
	db	rpt+4,65h
	db	rpt+2,67h
	db	2,49h
	db	40h
	db	rpt+17,50h
	db	5,5bh
	db	0ddh
	db	5dh
	db	50h
	db	0fh
	db	0

;
rdcode	DB	0
	DB	0d7h
	DB	2,40h
	DB	41h
	DB	rpt+3,40h
	DB	rpt+12,6dh
	DB	1,63h
	DB	rpt+4,65h
	DB	rpt+2,67h
	DB	1,49h
	DB	rpt+2,40h
	DB	rpt+12,6dh
	DB	3,63h
	DB	0e7h
	DB	67h
	DB	rpt+7,0fh
;
	DB	2,40h
	DB	41h
	DB	rpt+3,40h
	DB	rpt+12,6dh
	DB	1,63h
	DB	rpt+2,65h
	DB	rpt+2,60h
	DB	rpt+2,67h
	DB	1,0fh
	DB	0
;
;
m1	label	word
	dw	offset set_mode		;table of routines with IBM video i/o
	dw	offset set_ctype
	dw	offset set_cpos
	dw	offset read_cursor
	dw	offset read_lpen
	dw	offset act_disp_page
	dw	offset scrool_up
	dw	offset scrool_down
	dw	offset read_ac_current
	dw	offset write_ac_current
	dw	offset write_c_current
	dw	offset set_color
	dw	offset write_dot
	dw	offset read_dot
	dw	offset write_tty
	dw	offset video_state

m1L	equ	$ - m1
;
video_parms	label	byte

	db	38h,28h,2dh,0ah,1fh,6,19h	;for 40 x 25
	db	1ch,2,7,6,7
	db	0,0,0,0
m4	equ	$-video_parms

	db	71h,50h,5ah,0ah,1fh,6,19h	;for 80 x 25
	db	1ch,2,7,6,7
	db	0,0,0,0

	db	38h,28h,2dh,0ah,7fh,6,64h	;for graphics
	db	70h,2,1,6,7
	db	0,0,0,0

	db	61h,50h,52h,0fh,19h,6,19h	;for 80 x 25 on b/w card
	db	19h,2,0dh,0bh,0ch
	db	0,0,0,0
;
m5	label	word
	dw	2048				;40 x 25 length
	dw	4096				;80 x 25 
	dw	16384				;graphics
	dw	16384
;
m6	label	word
	db	40,40,80,80,40,40,80,80		;columns
;
m7	label	byte
	db	2ch,28h,2dh,29h,2ah,2eh,1eh,29h	;table of mode sets
;
;
k6	label	byte
	db	ins_key
	db	caps_key,num_key,scroll_key,alt_key,ctl_key
	db	left_key,right_key
k6L	equ	$-k6

k7	label	byte
	db	ins_shift
	db	caps_shift,num_shift,scroll_shift,alt_shift,ctl_shift
	db	left_shift,right_shift

k8	db	27,-1,0,-1,-1,-1,30,-1
	db	-1,-1,-1,31,-1,127,-1,-17
	db	23,5,18,20,25,21,9,15
	db	16,27,29,10,-1,1,19
	db	4,6,7,8,10,11,12,-1,-1
	db	-1,-1,28,26,24,3,22,2
	db	14,13,-1,-1,-1,-1,-1,-1
	db	' ',-1

k9	label	byte
	db	94,95,96,97,98,99,100,101
	db	102,103,-1,-1,119,-1,132,-1
	db	115,-1,116,-1,117,-1,118,-1
	db	-1

k10	label	byte
	db	01bh,'1234567890-=',08h,09h
	db	'qwertyuiop[]',0dh,-1,'asdfghjkl;',27h
	db	60h,-1,5ch,'zxcvbnm,./',-1,'*',-1,' '
	db	-1

k11	label	byte
	db	27,'!@#$',37,5eh,'&*()_+',08h,0
	db	'QWERTYUIOP{}',0DH,-1,'ASDFGHJKL:"'
	DB	7EH,-1,'|ZXCVBNM<>?',-1,0,-1,' ',-1

k12	label	byte
	db	84,85,86,87,88,89,90
	db	91,92,93

k13	label	byte
	db	104,105,106,107,108
	db	109,110,111,112,113

k14	label	byte
	db	'789-456+1230.'

k15	label	byte
	db	71,72,73,-1,75,-1,77
	db	-1,79,80,81,82,83

k30	label	byte			;Alt-input-table
	db	82,79,80,81,75,76,77
	db	71,72,73

	db	16,17,18,19,20,21,22,23
	db	24,25,30,31,32,33,34,35
	db	36,37,38,44,45,46,47,48
	db	49,50
;
v1	label	byte
	db	3,3,5,5,3,3,3,4
;
;**********************************************************************
;    CHARACTER GENERATOR GRAPHICS FOR 320X200 AND 640X200 GRAPHICS
;**********************************************************************

CRT_CHAR_GEN	LABEL	BYTE

	DB	000H,000H,000H,000H,000H,000H,000H,000H 		;
	DB	07EH,081H,0A5H,081H,0BDH,099H,081H,07EH 		;
	DB	07EH,0FFH,0DBH,0FFH,0C3H,0E7H,0FFH,07EH 		;
	DB	06CH,0FEH,0FEH,0FEH,07CH,038H,010H,000H 		;
	DB	010H,038H,07CH,0FEH,07CH,038H,010H,000H 		;
	DB	038H,07CH,038H,0FEH,0FEH,07CH,038H,07CH 		;
	DB	010H,010H,038H,07CH,0FEH,07CH,038H,07CH 		;
	DB	000H,000H,018H,03CH,03CH,018H,000H,000H 		;
	DB	0FFH,0FFH,0E7H,0C3H,0C3H,0E7H,0FFH,0FFH 		;
	DB	000H,03CH,066H,042H,042H,066H,03CH,000H 		;
	DB	0FFH,0C3H,099H,0BDH,0BDH,099H,0C3H,0FFH 		;
	DB	00FH,007H,00FH,07DH,0CCH,0CCH,0CCH,078H 		;
	DB	03CH,066H,066H,066H,03CH,018H,07EH,018H 		;
	DB	03FH,033H,03FH,030H,030H,070H,0F0H,0E0H 		;
	DB	07FH,063H,07FH,063H,063H,067H,0E6H,0C0H 		;
	DB	099H,05AH,03CH,0E7H,0E7H,03CH,05AH,099H 		;
	DB	080H,0E0H,0F8H,0FEH,0F8H,0E0H,080H,000H 		;
	DB	002H,00EH,03EH,0FEH,03EH,00EH,002H,000H 		;
	DB	018H,03CH,07EH,018H,018H,07EH,03CH,018H 		;
	DB	066H,066H,066H,066H,066H,000H,066H,000H 		;
	DB	07FH,0DBH,0DBH,07BH,01BH,01BH,01BH,000H 		;
	DB	03EH,063H,038H,06CH,06CH,038H,0CCH,078H 		;
	DB	000H,000H,000H,000H,07EH,07EH,07EH,000H 		;
	DB	018H,03CH,07EH,018H,07EH,03CH,018H,0FFH 		;
	DB	018H,03CH,07EH,018H,018H,018H,018H,000H 		;
	DB	018H,018H,018H,018H,07EH,03CH,018H,000H 		;
	DB	000H,018H,00CH,0FEH,00CH,018H,000H,000H 		;
	DB	000H,030H,060H,0FEH,060H,030H,000H,000H 		;
	DB	000H,000H,0C0H,0C0H,0C0H,0FEH,000H,000H 		;
	DB	000H,024H,066H,0FFH,066H,024H,000H,000H 		;
	DB	000H,018H,03CH,07EH,0FFH,0FFH,000H,000H 		;
	DB	000H,0FFH,0FFH,07EH,03CH,018H,000H,000H 		;
	DB	000H,000H,000H,000H,000H,000H,000H,000H 		;
	DB	030H,078H,078H,030H,030H,000H,030H,000H 		;
	DB	06CH,06CH,06CH,000H,000H,000H,000H,000H 		;
	DB	06CH,06CH,0FEH,06CH,0FEH,06CH,06CH,000H 		;
	DB	030H,07CH,0C0H,078H,00CH,0F8H,030H,000H 		;
	DB	000H,0C6H,0CCH,018H,030H,066H,0C6H,000H 		;
	DB	038H,06CH,038H,076H,0DCH,0CCH,076H,000H 		;
	DB	060H,060H,0C0H,000H,000H,000H,000H,000H 		;
	DB	018H,030H,060H,060H,060H,030H,018H,000H 		;
	DB	060H,030H,018H,018H,018H,030H,060H,000H 		;
	DB	000H,066H,03CH,0FFH,03CH,066H,000H,000H 		;
	DB	000H,030H,030H,0FCH,030H,030H,000H,000H 		;
	DB	000H,000H,000H,000H,000H,030H,030H,060H 		;
	DB	000H,000H,000H,0FCH,000H,000H,000H,000H 		;
	DB	000H,000H,000H,000H,000H,030H,030H,000H 		;
	DB	006H,00CH,018H,030H,060H,0C0H,080H,000H 		;
	DB	07CH,0C6H,0CEH,0DEH,0F6H,0E6H,07CH,000H 		;
	DB	030H,070H,030H,030H,030H,030H,0FCH,000H 		;
	DB	078H,0CCH,00CH,038H,060H,0CCH,0FCH,000H 		;
	DB	078H,0CCH,00CH,038H,00CH,0CCH,078H,000H 		;
	DB	01CH,03CH,06CH,0CCH,0FEH,00CH,01EH,000H 		;
	DB	0FCH,0C0H,0F8H,00CH,00CH,0CCH,078H,000H 		;
	DB	038H,060H,0C0H,0F8H,0CCH,0CCH,078H,000H 		;
	DB	0FCH,0CCH,00CH,018H,030H,030H,030H,000H 		;
	DB	078H,0CCH,0CCH,078H,0CCH,0CCH,078H,000H 		;
	DB	078H,0CCH,0CCH,07CH,00CH,018H,070H,000H 		;
	DB	000H,030H,030H,000H,000H,030H,030H,000H 		;
	DB	000H,030H,030H,000H,000H,030H,030H,060H 		;
	DB	018H,030H,060H,0C0H,060H,030H,018H,000H 		;
	DB	000H,000H,0FCH,000H,000H,0FCH,000H,000H 		;
	DB	060H,030H,018H,00CH,018H,030H,060H,000H 		;
	DB	078H,0CCH,00CH,018H,030H,000H,030H,000H 		;
	DB	07CH,0C6H,0DEH,0DEH,0DEH,0C0H,078H,000H 		;
	DB	030H,078H,0CCH,0CCH,0FCH,0CCH,0CCH,000H 		;
	DB	0FCH,066H,066H,07CH,066H,066H,0FCH,000H 		;
	DB	03CH,066H,0C0H,0C0H,0C0H,066H,03CH,000H 		;
	DB	0F8H,06CH,066H,066H,066H,06CH,0F8H,000H 		;
	DB	0FEH,062H,068H,078H,068H,062H,0FEH,000H 		;
	DB	0FEH,062H,068H,078H,068H,060H,0F0H,000H 		;
	DB	03CH,066H,0C0H,0C0H,0CEH,066H,03EH,000H 		;
	DB	0CCH,0CCH,0CCH,0FCH,0CCH,0CCH,0CCH,000H 		;
	DB	078H,030H,030H,030H,030H,030H,078H,000H 		;
	DB	01EH,00CH,00CH,00CH,0CCH,0CCH,078H,000H 		;
	DB	0E6H,066H,06CH,078H,06CH,066H,0E6H,000H 		;
	DB	0F0H,060H,060H,060H,062H,066H,0FEH,000H 		;
	DB	0C6H,0EEH,0FEH,0FEH,0D6H,0C6H,0C6H,000H 		;
	DB	0C6H,0E6H,0F6H,0DEH,0CEH,0C6H,0C6H,000H 		;
	DB	038H,06CH,0C6H,0C6H,0C6H,06CH,038H,000H 		;
	DB	0FCH,066H,066H,07CH,060H,060H,0F0H,000H 		;
	DB	078H,0CCH,0CCH,0CCH,0DCH,078H,01CH,000H 		;
	DB	0FCH,066H,066H,07CH,06CH,066H,0E6H,000H 		;
	DB	078H,0CCH,0E0H,070H,01CH,0CCH,078H,000H 		;
	DB	0FCH,0B4H,030H,030H,030H,030H,078H,000H 		;
	DB	0CCH,0CCH,0CCH,0CCH,0CCH,0CCH,0FCH,000H 		;
	DB	0CCH,0CCH,0CCH,0CCH,0CCH,078H,030H,000H 		;
	DB	0C6H,0C6H,0C6H,0D6H,0FEH,0EEH,0C6H,000H 		;
	DB	0C6H,0C6H,06CH,038H,038H,06CH,0C6H,000H 		;
	DB	0CCH,0CCH,0CCH,078H,030H,030H,078H,000H 		;
	DB	0FEH,0C6H,08CH,018H,032H,066H,0FEH,000H 		;
	DB	078H,060H,060H,060H,060H,060H,078H,000H 		;
	DB	0C0H,060H,030H,018H,00CH,006H,002H,000H 		;
	DB	078H,018H,018H,018H,018H,018H,078H,000H 		;
	DB	010H,038H,06CH,0C6H,000H,000H,000H,000H 		;
	DB	000H,000H,000H,000H,000H,000H,000H,0FFH 		;
	DB	030H,030H,018H,000H,000H,000H,000H,000H 		;
	DB	000H,000H,078H,00CH,07CH,0CCH,076H,000H 		;
	DB	0E0H,060H,060H,07CH,066H,066H,0DCH,000H 		;
	DB	000H,000H,078H,0CCH,0C0H,0CCH,078H,000H 		;
	DB	01CH,00CH,00CH,07CH,0CCH,0CCH,076H,000H 		;
	DB	000H,000H,078H,0CCH,0FCH,0C0H,078H,000H 		;
	DB	038H,06CH,060H,0F0H,060H,060H,0F0H,000H 		;
	DB	000H,000H,076H,0CCH,0CCH,07CH,00CH,0F8H 		;
	DB	0E0H,060H,06CH,076H,066H,066H,0E6H,000H 		;
	DB	030H,000H,070H,030H,030H,030H,078H,000H 		;
	DB	00CH,000H,00CH,00CH,00CH,0CCH,0CCH,078H 		;
	DB	0E0H,060H,066H,06CH,078H,06CH,0E6H,000H 		;
	DB	070H,030H,030H,030H,030H,030H,078H,000H 		;
	DB	000H,000H,0CCH,0FEH,0FEH,0D6H,0C6H,000H 		;
	DB	000H,000H,0F8H,0CCH,0CCH,0CCH,0CCH,000H 		;
	DB	000H,000H,078H,0CCH,0CCH,0CCH,078H,000H 		;
	DB	000H,000H,0DCH,066H,066H,07CH,060H,0F0H 		;
	DB	000H,000H,076H,0CCH,0CCH,07CH,00CH,01EH 		;
	DB	000H,000H,0DCH,076H,066H,060H,0F0H,000H 		;
	DB	000H,000H,07CH,0C0H,078H,00CH,0F8H,000H 		;
	DB	010H,030H,07CH,030H,030H,034H,018H,000H 		;
	DB	000H,000H,0CCH,0CCH,0CCH,0CCH,076H,000H 		;
	DB	000H,000H,0CCH,0CCH,0CCH,078H,030H,000H 		;
	DB	000H,000H,0C6H,0D6H,0FEH,0FEH,06CH,000H 		;
	DB	000H,000H,0C6H,06CH,038H,06CH,0C6H,000H 		;
	DB	000H,000H,0CCH,0CCH,0CCH,07CH,00CH,0F8H 		;
	DB	000H,000H,0FCH,098H,030H,064H,0FCH,000H 		;
	DB	01CH,030H,030H,0E0H,030H,030H,01CH,000H 		;
	DB	018H,018H,018H,000H,018H,018H,018H,000H 		;
	DB	0E0H,030H,030H,01CH,030H,030H,0E0H,000H 		;
	DB	076H,0DCH,000H,000H,000H,000H,000H,000H 		;
	DB	000H,010H,038H,06CH,0C6H,0C6H,0FEH,000H 		;
;
;
code	ends
;
LASTSEG	Segment	Byte	Public 'ROMBIOS'
	Assume cs:code,ds:code,es:code,ss:Nothing


	Org	0fff0h			;RESET ADDRESS FOR 8086

	DB	0EAH,00H,05H,00H,00H	;8086 WILL JUMP TO 0000:0500H
					;At this location will be either a
					;far jump back to the start of this
					;monitor or a jump to cpm86/MSDOS
					;then in RAM
	ORG	0FFF6H
	DB	01H,01H			;8089 SET FOR 16 BIT MEMORY
	DB	10H,05H,00H,00H		;8089 WILL JUMP TO 0000:0510H
					;WHERE IT WILL FIND ITS SYSTEM
					;CONFIGURATION BLOCK
	db	0ffh,0ffh,0ffh		;FOR IBM COMPATABILITY

	;db	0ffh			;CHECKSUM <--this should be hand entered in rom
LASTSEG	ends				;            as assembler does not put it in.
end

